<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {make_btn} function plugin
 *
 * File:       function.make_btn.php<br>
 * Type:       function<br>
 * Name:       make_btn<br>
 * Date:       2007-11-15<br>
 * Purpose:    Prints out a list of checkbox input types<br>
 * Input:<br>
 *           - napis      (required) - string default "checkbox"
 *           - adres      (optional) - string default ""
 *           - parametry  (optional) - string default array()
 * Examples:
 * <pre>
 * {make_btn napis="Przycisk" output="index.php"}
 * {make_btn napis="Przycisk" output="#" onclick="document.forms[0].submit();" style="color: red;"}
 * </pre>
 * @author     Jarek Kotowski <jarek@solution-4u.com>
 * @version    1.0
 * @param array
 * @param Smarty
 * @return string
 */
function smarty_function_button($params, &$smarty){
    GLOBAL $SZABLON_IMG_URL;
    
    $napis = '';
	  $icon = '';
    $adres = '';
    $parametry = array();
    $extra = '';
    $css = '';

    foreach($params as $_key => $_val) {
        switch($_key) {
            case 'napis':
                //$$_key = isset( $smarty->lang[$_val] )? $smarty->lang[$_val] : ((string)$_val);
                $$_key = (string)$_val;
            break;

            case 'name':
                //$lang = $smarty->get_template_vars('lang');
                //$napis = isset( $smarty->lang[$_val] )? $smarty->lang[$_val] : ((string)$_val);
                $napis  = (string)$_val;
            break;

            case 'adres':
                $$_key = (string)$_val;
            break;

            case 'class':
                $css = (string)$_val;
            break;
			
			case 'icon':
                $icon = (string)$_val;
            break;

            default:
                if( !is_array($_val) ) {
                    $extra .= ' '.$_key.'="'.addcslashes($_val, '\\"').'"';
                }
            break;
        }
    }

    //$SZABLON_URL = $smarty->get_template_vars('SZABLON_URL');

    return 'button '.( empty($icon) ? '' : '{button:{icons:{primary:'."'ui-icon-".$icon."'".'}}}');

}


?>
