
(function($){
    var $ecImageSizeDialog;
    var currentIndex = -1;
    var $element = null;

    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function _init( options ){
        var $target =  $(options.target);

        if( $target.data ( 'ecImageSizesOptions') ){
            return false;
        }

        $target.data ( 'ecImageSizesOptions', options );


        /**
         * Tabela wymiarw obrazkw
         */
        $target.html('<table class="grid" width="80%" border=0 cellspacing=0 cellpading=5>' + "\n" +
                '<tr>' + "\n" +
                    '<th width="15px">Lp.</th>' + "\n" +
                    '<th>Etykieta</th>' + "\n" +
                    '<th width="100px">Szeroko</th>' + "\n" +
                    '<th width="100px">Wysoko</th>' + "\n" +
                    '<th width="100px">Akcje</th>' + "\n" +
                 '</tr>' + "\n" +
            '</table>');

        if ( options.items ) {
            printTable( $target.find('table'), options.items );
        }
    }

    function intval( val ){
        if ( typeof(val) == 'string' ) {
            val = val.replace(',', '.');
        }

        val = parseInt(val);
        if ( isNaN(val) ) {
            val = 0;
        }

        return val;
    }

    function printTable( $table, items ) {
        var rows = $table.find('tr');

        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        if ( items ) {
            for ( var i = 0; i < items.length; i++ ) {
                $table.append( printTableRow(items[i], i+1) );
            }
        }
    }

    function printTableRow ( item, lp ) {
        var $row = $('<tr>');
        $row.dblclick(ecImageSizeDelete);

        if ( lp % 2 === 1 ) {
            $row.addClass('odd');
        } else {
            $row.addClass('even');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(ecImageSizeDelete);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(ecImageSizeEdit);

        var $td = $('<td>');

        $row.append($td.clone().html( lp + '. ' ).attr('align', 'right').attr('class', 'num'));
        $row.append($td.clone().html( item.label ).attr('align', 'left') );
        $row.append($td.clone().html( item.width + ' px').attr('align', 'right') );
        $row.append($td.clone().html( item.height + ' px').attr('align', 'right') );
        $row.append($td.attr('align', 'center').append( $a_edit  ).append($a_del) );

        return $row;
    }

    /**
     * Rabat progi on click
     */
    function onClickHandler( e ){
        e.preventDefault();

        var href = $(this).attr('href');
        var href_match = href ? href.match(/#.*$/) : false;
        if ( href_match ) {
            href = href_match[0]
        }

        if ( href ) {
            $element = $( href );

            if ( $element.length === 1 ) {
                currentIndex = -1;
                ecImageSizeDialogOpen();
            } else {
                console.log('Nie znaleziono obiektu: ' + href );
            }
        }

        return false;
    }


    function ecImageSizeSave( e ){
        if( e && e.preventDefault() ) e.preventDefault();

        var errors = {};
        var item = {};

        item.label = $ecImageSizeDialog.find('input[name=label]').val();
        item.width = intval($ecImageSizeDialog.find('input[name=width]').val());
        item.height = intval($ecImageSizeDialog.find('input[name=height]').val());

        if ( item.width <= 0 ) {
            errors.width = "Szeroko musi by wiksza od zera";
        }

        if ( item.height <= 0 ) {
            errors.height = "Wysoko musi by wiksza od zera";
        }

        if ( errors.width || errors.height) {
            var msg = '';
            if ( typeof($.validator) !== 'undefined' ) {
                $ecImageSizeDialog.find('form').validate().showErrors( errors );
            } else {
                msg += "\n";

                for ( var e in errors ){
                    msg += errors[e] + "\n";
                }
            }

            alert('Popraw bdy!' + msg );
        } else {
            var options = $element.data('ecImageSizesOptions');

            if ( currentIndex === -1) {
                $element.find('table').append(printTableRow ( item, options.items.length+1 ) ) ;
                options.items.push(item);
            } else {
                $element.find('tr:eq('+(currentIndex+1)+')').replaceWith( printTableRow ( item,  currentIndex+1 ) );
                options.items[currentIndex] = item;
            }

            $element.data('ecImageSizesOptions', options);
            $ecImageSizeDialog.dialog('close');

            appendInputs();
        }

        return false;
    }

    function appendInputs ( ) {
        var options = $element.data('ecImageSizesOptions');
        $element.find('input').remove();

        for ( var i = 0; i < options.items.length ; i++  ){
            for ( var a in options.items[i] ) {
                $element.append('<input type="hidden" name="'+options.input+'[' + i + '][' + a + ']" value="' + options.items[i][a] + '" />');
            }
        }
    }

    function ecImageSizeDialogOpen ( item ) {

        if( !$ecImageSizeDialog ){
            $ecImageSizeDialog  = $('#ecImageSizeDialog').dialog({
                'open' : false,
                'width' : 600,
                'height' : 300,
                'buttons' : {
                    'Anuluj' : function(){
                        $ecImageSizeDialog.dialog('close');
                    },

                    'OK' : ecImageSizeSave
                }
            });

            $ecImageSizeDialog.find('input[type=submit]').hide();
            $ecImageSizeDialog.find('form').submit(ecImageSizeSave);
        }

        if ( currentIndex == -1 ){
            $ecImageSizeDialog.dialog('option', 'title', 'Dodawanie nowych wymiarw obrazka');
        } else {
            $ecImageSizeDialog.dialog('option', 'title', 'Edycja wymiarw obrazka');
        }

        $ecImageSizeDialog.find('input[type=text]').val('');
        if ( item ) {
            for ( var a in item ) {
                $ecImageSizeDialog.find('input[name=' + a + ']').val(item[a]);
            }
        }

        $ecImageSizeDialog.dialog('open');
    }

    function ecImageSizeEdit ( e ) {
        e.preventDefault();
        $element = $(this).parents('table:first').parent();

        var $tr = $(this).parents('tr:first');
        currentIndex = $tr.index() - 1;

        var options = $element.data('ecImageSizesOptions');
        ecImageSizeDialogOpen( options.items[currentIndex] );

        return false;
    }

    function ecImageSizeDelete ( e ) {
        e.preventDefault();

        if ( confirm('Jeste pewien, e chcesz usun wymiary obrazka ?') ) {
            var $tr = $(this).parents('tr:first');
            var $table = $tr.parents('table:first');

            $element = $table.parent();

            currentIndex = $tr.index() - 1;
            var options = $table.parent().data('ecImageSizesOptions');
            options.items.splice( currentIndex, 1);

            $tr.remove();

            $table.find('tr:gt(0)').each(function( i, el ){
                $(el).attr('class', ((i+1) % 2)  ? 'odd' : 'even');
                $(el).find('td.num').html( (i + 1) + '.');
            });

            appendInputs();
        }

        return false;
    }

    if ( $.fn.imageSizes && typeof($.fn.imageSizes) === 'function' ) {
        return;
    }

    $.fn.ecImageSizes = function( options ){
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        options = $.extend({
            items  : [],
            input  : 'ecImageSizes',
            name   : $(this).attr('id'),
            target : $(this).attr('href'),
            title  : $(this).attr('title'),
            select : ''
        }, options || {} );

        if ( options.target && options.target.substr(0, 1) != '#' ){
            options.target = '#' + options.target;
        }

        if ( typeof(options.items) !== 'object' || options.items === null || typeof(options.items.length) === 'undefined' ) {
            options.items = [];
        }

        _init( options );

        if ( this.is('a') ) {
            this.button({
                'text' : false,
                'icons' : {
                    'primary' : 'ui-icon-image'
                }
            }).click ( onClickHandler );
        }
    }
})(jQuery);
