/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

if( jQuery.validator ){
    jQuery.validator.addMethod("paczkomatyConfig", function(value, element) {
        return this.optional(element) || /^[a-zA-Z\-_]+$/i.test(value);
    }, "Nazwa konfiguracji moe skada si wycznie z liter i cyfr");
}

var Paczkomaty = {
    'zk_info_url' : '',
    'status_info_url' : '',
    'payment_url' : '',
    'cancel_url' : '',
    'config' : '', //nazwa aktywnej konfiguracji
    'settings' : null,
    'template' : null, //nazwa aktywnego szablonu
    'templates' : null,
    'options' : [], //opcje do selecta
    'zamowienia' : [], //opcje do selecta
    'machines' : null,
    'cache' : {
        'emails' : {},
        'postcodes0': {},
        'postcodes1': {}
    },
    customer : null,
    postcode_machines : null,
    callback: function(){
        console.log(arguments);
    },
    //dane wysylki
    'sender' : null,
    //numer kliknietego zamwienia
    zk_id : 0
};

(function(){
    var $settingsDialog, $paczkomatMapBtn, $paymentDialog, $printoutDialog, $cancelDialog, $paczkaInfoDialog, $labelDialog, $zkStatusDialog, $paczkaDialog, $paczkaDialog, $zkPaczkomatDialog, $settingsValidator, $dialog, $activeDialog, zkSelection;

    var dialogOptions = {
          title: '',
          bgiframe: true,
          show: 'clip',
          hide: 'clip',
          width: 'auto',
          height: 'auto',
          minWidth: 300,
          minHeight: 100,
          maxWidth: 800,
          closeOnEscape: true,
          autoOpen: false,
          modal: false,
          draggable: true,
          'open': function(event, ui) {
              showTlo();
          },
          'close': function(){
              hideTlo();
          }
    };

    var metadataOptions = {
        type: 'attr',
        name: 'data'
    }

/**************************************************************************************************/
    function __html_replace( html, data, prefix ){
        if ( !prefix ) prefix = '%';

        if ( html && typeof(data) == 'object') {
            for ( var key in data ){
                 if ( typeof(data[key]) == 'object' ){
                    html = __html_replace( html, data[key], prefix + key + '\\.' );
                }else if ( typeof(data[key]) == 'string' || typeof(data[key]) == 'number' ){
                    html = html.replace(new RegExp( prefix + key + '%','g'), data[key]);
                }
            }
        }

        return html;
    }

    function print_object( template, data ){
        var html = jQuery(template).clone(false).removeClass('template').show().wrap('<div></div>');

        html = __html_replace( html.parent().html(), data );
        html = html ? html.replace(new RegExp( '%[a-zA-Z0-9_\\.\\-]+%','g'), '&nbsp;') : '';

        return html;
    }

    function save_object( data, options ){//wstawia obiekt zwrcony z serwera do HTML
        var html = print_object('#'+ options.model_parent + ' ' + ( options.tpl ? options.tpl : '.tpl') , data);

        if ( empty(html) ) {
            console.log('Nie znaleziono obiektu: ' + '#' + options.model_parent + ' .tpl');
            return false;
        }

        var insert = jQuery(html);
        if( options.attach_handlers && typeof(options.attach_handlers) == 'function' ){
            try{
                options.attach_handlers(insert);
            }catch(err){
                if ( console && console.log && typeof(console.log) == 'function' ){
                    console.log(err);
                }
            }
        }

        if ( options.mode && (options.mode == 'edit' || options.mode == 'update') ) {
            jQuery( '#' + options.model + data.id ).replaceWith(insert);
        } else {
            insert.css("display", "none");
            jQuery( '#'+ options.model_parent ).append(insert);
            insert.fadeIn("slow");
        }
    }

/**************************************************************************************************/

    var settingsAjax = {
        error: function(jqXHR, textStatus, errorThrown){
            //console.log(textStatus);
            //console.log(jqXHR);
            //console.log(errorThrown);

            hideLoading();
            print_message( 'Przez serwer zostaa zwrcona nieprawidowa odpowied' );

            if ( $activeDialog ) {
                $activeDialog.dialog("enable");
                $activeDialog.dialog("close");
                $activeDialog = null;
            }
        },

        beforeSubmit:  function(){
            if( $activeDialog ){
                $activeDialog.dialog("disable");
            }
            showLoading(0, 0, 1100);
        }
    }

    function settingsOptions() {
        var $select = $('#paczkomatySettingsDialog').find('select[name=config]');
        var option = null, update = false;

        if( !Paczkomaty.options ){
            Paczkomaty.options = [];
        }

        if ( Paczkomaty.settings && (!Paczkomaty.options || Paczkomaty.options.length == 0) ) {
            Paczkomaty.options = [];
            for( var o in Paczkomaty.settings ){
                if( typeof(Paczkomaty.settings[o]) == 'object' ){
                    Paczkomaty.options.push(o) ;
                }
            }

            update = true;
        }

        if ( !$select.val() ) {
            option = $('#paczkomatySettingsDialog').find('input[name=nazwa]').val();
        }

        if ( option ) {
            Paczkomaty.options.push(option);

            update = true;
        }

        if ( update ) {
            $select.children('option:gt(0)').remove();

            Paczkomaty.options.sort();
            for ( var i = 0; i < Paczkomaty.options.length ; i++ ) {
                $select.append('<option value="' + Paczkomaty.options[i]+ '">' + Paczkomaty.options[i] + '</option>');
            }
        }
    }

    function settingsTemplates() {
        var $select = $('#paczkomatySettingsDialog').find('select[name=szablon]');
        var opts = [];

        if ( Paczkomaty.templates ) {
            for( var o in Paczkomaty.templates ){
                if( typeof(Paczkomaty.templates[o]) == 'object' ){
                    opts.push(o) ;
                }
            }
        }

        $select.children('option:gt(0)').remove();

        opts.sort();
        for ( var i = 0; i < opts.length; i++ ) {
            $select.append('<option value="' + opts[i]+ '">' + opts[i] + '</option>');
        }
    }

    function settingsOpen( e ){
        e.preventDefault();

        if ( !$settingsDialog ) {
            dialogOptions.title = 'Paczkomaty konfiguracja API';
            dialogOptions.buttons = [
                {
                    text: "Anuluj",
                    icons : {
                        'primary' : 'ui-icon-cancel'
                    },
                    click: function() {$(this).dialog("close");}
                },
                {
                    text: "Usu",
                    icons : {
                        primary : 'ui-icon-trash'
                    },
                    click: settingsDelete
                },
                {
                    text: "Zapisz",
                    icons : {
                        primary : 'ui-icon-disk'
                    },
                    click: function() {
                        $(this).find("form").submit();
                    }
                }
            ];

            $settingsDialog = $('#paczkomatySettingsDialog').dialog( dialogOptions );

            $settingsDialog.find('input[type=submit]').hide();

            $settingsDialog.find('.set-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-circle-check'
                },
                'text' : false
            }).click(settingsSet);

            $settingsDialog.find('select[name=config]').change(settingsSelect);

            settingsOptions();

            $settingsValidator = $settingsDialog.find('form').validate({
                submitHandler: settingsSave
            });
        }

        settingsTemplates();
        $settingsDialog.dialog('open');

        return false;
    }

    function settingsSave( form ) {
        $activeDialog = $settingsDialog;

        jQuery(form).ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsOptions();
                    settingsUpdate();

                    $('.clearable', form).clearFields();
                    if( $settingsDialog.find('select[name=config]')[0] ) {
                        $settingsDialog.find('select[name=config]')[0].selectedIndex = 0;
                    }

                    if( typeof(data.sender) != 'undefined' ){
                        Paczkomaty.sender = data.sender;
                    }

                    if ( typeof(data.insurance_options) != 'undefined' ) {
                        Paczkomaty.insurance_options = data.insurance_options;

                        var $select = $('#paczkomatyPaczkaInsurance');
                        $select.children('option:gt(0)').remove();
                        for ( var o in data.insurance_options ) {
                            $select.append('<option value="' + o + '">' + data.insurance_options[o] + '</option>');
                        }
                    }

                    $settingsDialog.dialog("close");
                    $activeDialog = null;
                } else {
                    $settingsValidator.showErrors(data.object);
                }
            }
        }));
    }

    function settingsSet( e ){
        e.preventDefault();

        var config = $('#paczkomatySettingsDialog input[name=nazwa]').val();

        if ( !config || config == '' ) {
            print_message( 'Wybierz konfiguracj ktr chcesz uzywa do polczenia si z serwisem WebApi sidemki' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': this.href,
            'dataType':  'json',
            'data':  {'config' : config},

            'success': function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsUpdate()
                }
            }
        }));

        //console.log(settingsAjax);

        return false;
    }

    function settingsDelete( e ){
        e.preventDefault();

        var config = $('#paczkomatySettingsDialog input[name=nazwa]').val();

        if ( !config ) {
            print_message( 'Wybierz konfiguracj ktr chcesz usun' );
            return false;
        }
        var mode = $('#paczkomatySettingsDialog input[name=mode]').val();

        $.ajax($.extend({}, settingsAjax, {
            'url': Paczkomaty.url,
            'dataType':  'json',
            'data':  {'mode' : mode, 'delete' : config},

            'success': function(data) {
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    if ( config && Paczkomaty.settings[config] ){
                        delete Paczkomaty.settings[config];
                        $('#paczkomatySettingsDialog form').clearForm();
                        Paczkomaty.options = [];
                        settingsOptions();
                    }
                }
            }
        }));

        return false;
    }

    function formSetValues( form, data, opcje ) {
        var $form = $(form), el = '';

        if ( typeof(opcje) == 'undefined' ){
            opcje = {};
        }

        if ( typeof(opcje) != 'object' ){
            opcje = {'clear' : opcje};
        }

        opcje  = $.extend({
            'clear' : false,
            'prefix' : '',
            'sufix' : ''
        }, opcje);

        if ( opcje.clear ) {
            if ( typeof(opcje.clear) == 'object' ) {
                opcje.clear.clearFields();
                //console.log( data );
//                for( var i = 0; i < opcje.clear.length; i++ ){
//                    console.log( (i+1) + '. ' + opcje.clear[i].name );
//                }
            } else if ( typeof(opcje.clear) == 'string' ) {
                $form.find(opcje.clear).clearFields();
            }else{
                $form.clearForm();
            }

            $form.find('input[title]').each(function(){
                if( (!this.value || this.value == '') && this.title ){
                    this.value = this.title;
                }
            });
        }

        if ( typeof(data) == 'object' ){
            for ( var f in data ) {
                el = opcje.prefix + f + opcje.sufix;
                //console.log('el: ' + el + ' = ' + data[f] );
                if ( typeof(data[f]) == 'object' ) {
                    formSetValues(form, data[f], {
                        'prefix' : el + '[',
                        'sufix' : ']'
                    });
                } else if ( form.elements[el] ) {
                    //console.log(form.elements[el]);
                    //mamy radio
                    if ( form.elements[el][0] && typeof(form.elements[el][0].type) == 'string' ) {
                        for( var i = 0; i < form.elements[el].length; i++  ){
                            if( form.elements[el][i].value == data[f] ){
                                form.elements[el][i].checked = true;
                            } else {
                                form.elements[el][i].checked = false;
                            }
                        }
                    }else if ( form.elements[el].type == 'checkbox' ) {
                        form.elements[el].checked = (data[f] > 0);
                    } else {
                        $(form.elements[el]).val(data[f]);
                    }
                }
            }
        }

    }

    function object_deflatte ( fData ) {
        var object = new Object(), deflatte = {}, pos, k, p;

        for ( var f in fData ) {
            pos = f.indexOf('[');

            if ( pos > -1 ) {
                k = f.substring(0, pos);
                p = f.substring(pos + 1, f.indexOf(']') );

                object[k][p] = fData[f];

                if ( p.indexOf('[') > -1 && typeof(deflatte[k]) == 'undefined' ){
                    deflatte[k];
                }
            } else {
                object[f] = fData[f];
            }
        }

        for ( k in deflatte ) {
            object[k] = object_deflatte( object[k] );
        }

        return object;
    }

    function formGetValues( form ) {
        var $form = $(form), data = new Object();

        var some_data = $form.find("input, select").map(function(){
            return {'name': $(this).attr('name'), 'value': ( this.type && this.type == 'checkbox' ) ? (this.checked ? '0' : this.value) : $(this).val()};
        }).get();

        for ( var i = 0; i < some_data.length; i++  ) {
            if ( some_data[i].name ) {
                data[some_data[i].name] = some_data[i].value;
            }
        }

        data = object_deflatte( data );

        //console.log(data);
        return data;
    }

    function settingsSelect(){
        var clear = true;

        if ( this.value ) {
            if ( Paczkomaty && Paczkomaty.settings && Paczkomaty.settings[this.value] ) {
                formSetValues(this.form, Paczkomaty.settings[this.value], {'clear' : false});
                clear = false;
            }
        }

        if ( clear ) {
            $(this.form).clearForm();
        }
    }

    function settingsUpdate(){
        var settingsList = $('#paczkomatySettingsDialog input, #paczkomatySettingsDialog select').each(function(){
            var value = null;
            if( this.type == 'checkbox' ){
                value = (this.checked ? this.value : false);
            } else {
                value = this.value;
            }

            return {'name' : this.name, 'value' : value};
        });

        var i, settings = {};
        for ( i = 0 ;  i < settingsList.length; i++ ){
            settings[settingsList[i].name] = settingsList[i].value;
        }

        Paczkomaty.config = settings.nazwa;
        if(!Paczkomaty.settings){
            Paczkomaty.settings = new Object();
        }
        Paczkomaty.settings[settings.nazwa] = settings;

        $('#paczkomatyApiNazwa').html(settings.nazwa);

        $('#paczkomatyApiError').fadeOut('slow', function(){
            $(this).remove();
        });
    }

/**************************************************************************************************/
    function sprawdzWybraneZamowienia( nr_paczki, status, message ){
        if ( zkSelection.selected.length == 0 ){
            print_message('Naley wybra zamwienia');
            return false;
        }

        //czy sprawdzac czy zaznaczone zamwienia maja nadany numer paczki
        if ( nr_paczki ){
            var count = 0;
            for ( var i = 0; i < zkSelection.selected.length; i++ ) {
                id = zkSelection.selected[i];

                if ( typeof(nr_paczki) == 'string' && nr_paczki === 'brak' ) {
                    if (  zkSelection.records[id] && (!zkSelection.records[id]['numer_przesylki'] || zkSelection.records[id]['numer_przesylki'] == '') ) {
                        count++;
                    }
                }else if ( zkSelection.records && zkSelection.records[id] && typeof(zkSelection.records[id]['numer_przesylki']) != 'undefined' && zkSelection.records[id]['numer_przesylki'] ) {
                    if ( !status || status == zkSelection.records[id]['przesylka_status'] ) {
                        count++;
                    }
                }
            }

            if ( count == 0 ) {
                if ( message ) {
                    print_message(message);
                } else if( typeof(nr_paczki) == 'string' && nr_paczki === 'brak' ){
                    print_message('Dla wszystkich wybranych zamwie s ju utworzone paczki w systemie paczkomaty.pl.');
                }else{
                    print_message('Dla adnego z wybranych zamwie nie ma utworzonej paczki w systemie paczkomaty.pl. Najpierw utwrz paczki dla zamwie.');
                }

                return false;
            }
        }

        return true;
    }

/**************************************************************************************************/

    function zkStatusSave() {
        if ( !sprawdzWybraneZamowienia() ) {
            return false;
        }

        var $form  = $(this);
        zkSelection.appendTo(this);

        //this.submit(); return true;
        var $status = $form.find('select[name=opis_stanu]');
        var status_id = $status.val(), status = null;
        if ( status_id > 0 ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        } else {
            print_message( 'Wybierz status jaki chcesz ustawi dla wybranych zamwie');
            return false;
        }

        showLoading();
        $zkStatusDialog.dialog('disable');
        $activeDialog = $zkStatusDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $zkStatusDialog.dialog( "enable" );

                print_message( data.message );

                //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                if ( data.object ) {
                    var zk_id, $zk_row, i;

                    for ( i = 0; i < data.object.length; i++ ) {
                        if ( data.object[i].error ){
                            continue;
                        }

                        zk_id = data.object[i].id;
                        $zk_row = $('#zamowienie' + zk_id + '_row');

                        if ( $zk_row.length ) {
                            $zk_row.find('.zk-status').html( status );
                        }
                    }
                }

                if ( !data.error ) {
                    $zkStatusDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }


    function zkStatusOpen( e ){
        e.preventDefault();

        if ( !$zkStatusDialog ) {
            $zkStatusDialog = $('#zamowieniaStatusDialog').dialog( $.extend({},dialogOptions, {
                'title' : this.title,
                'width' : '700px',
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zmie",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {
                            $(this).find("form").submit();
                        }
                    }
                ]
            }));

            $zkStatusDialog.find('input[type=submit]').hide();
            $zkStatusDialog.find('form').submit(zkStatusSave);
        }

        if ( zkSelection.selected.length > 0 ) {
            zkSelectedPrint($zkStatusDialog.find('.zamowienia'));
        } else {
            sprawdzWybraneZamowienia();
            return false;
        }

        $zkStatusDialog.dialog('open');

        return false;
    }

/**************************************************************************************************/

    function zkRowPaczkaUpdateStatus( $zk_row, status ){
        if ( $zk_row && $zk_row.length == 1 )  {
            zk = $zk_row.metadata(metadataOptions);
            zk.przesylka_status = status;
            $zk_row.attr('data', JSON.stringify(zk));

            $zk_row.find('.przesylka-status').html(status);
        }
    }

    function paczkaGetSticker() {
        var $form  = $(this);

        var zk = $labelDialog.data('zk');
        if ( !zk && !sprawdzWybraneZamowienia(true) ) {
            return false;
        }

        $form.find('input[name^=selected]').remove();
        if (  zk ) {
            $form.append('<input type="hidden" name="selected['+zk.id+']" value="' + zk.numer_przesylki + '" />');
        }else{
            var selected  = zkPaczkiPrintCheck();

            if ( !selected ) {
                return false;
            }

            zkSelection.appendTo(this, {
                'field' : 'numer_przesylki',
                'assoc' : true,
                'selected' : selected

            });
        }

        showLoading();
        $labelDialog.dialog('disable');
        $activeDialog = $labelDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType': 'json',
            'success': function(data){
                hideLoading();
                $labelDialog.dialog( "enable" );

                if ( data && !data.error ) {
                    var id = 0, $zk_row;
                    if ( zk ) {
                        if ( zk.przesylka_status == 'Created' ) {
                            $zk_row = $('#zamowienie' + zk.id + '_row');
                            zkRowPaczkaUpdateStatus($zk_row, 'Prepared');
                        }
                    } else {
                        for ( var i = 0; i < zkSelection.selected.length; i++ ) {
                            id = zkSelection.selected[i];

                            //zmieniam status jesli status jest Created
                            if ( zkSelection.records && zkSelection.records[id] && zkSelection.records[id]['numer_przesylki'] && zkSelection.records[id]['numer_przesylki'] == 'Created' ) {
                                $zk_row = $('#zamowienie' + id + '_row');
                                zkRowPaczkaUpdateStatus($zk_row, 'Prepared');
                            }
                        }
                    }
                }

                if ( data && data.message ) {
                    print_message( data.message );

                    $labelDialog.find('.message_' + data.message.type).html(data.message.body).slideDown();
                    $labelDialog.find('.message_' + data.message.type + ' a').click(function(){
                        $labelDialog.dialog("close");
                        $activeDialog = null;
                    });

                    return;
                }

                if ( !data.error ) {
                    $labelDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }

    function zkPaczkiPrintCheck(printout){
        if ( !zkSelection.selected.length ) {
            if( printout ) {
                print_message('Musisz wybra zamwienia, dla ktrych ma zosta wydrukowane potwierdzenie nadania utworzonych do nich paczek.');
            } else {
                print_message('Musisz wybra zamwienia, dla ktrych maj zosta wydrukowane etykiety do utworzonych do nich paczek.');
            }
            return false;
        }

        var count = 0, countCancelled = 0; var selected = [], id;
        for ( var i = 0; i < zkSelection.selected.length; i++ ) {
            id = zkSelection.selected[i];

            if ( zkSelection.records && zkSelection.records[id] && zkSelection.records[id]['numer_przesylki'] ) {
                count++;

                if ( zkSelection.records[id]['przesylka_status'] == 'Cancelled' ) {
                    countCancelled++;
                } else{
                    selected.push(id);
                }
            }
        }

        if ( !count ) {
            print_message('Dla adnego z wybranych zamwie nie zostaa utworzona paczka.');
            return false;
        }

        //
        if ( count == countCancelled || selected.length == 0 ) {
            if( printout ) {
                print_message('Nie moe wydrukowa potwierdzenie nadania, poniewa dla wszystkich wybranych zamwie utworzone dla nich paczki zostay anulowane, maj status: Cancelled.');
            } else {
                print_message('Nie moe wydrukowa etykiet, poniewa dla wszystkich wybranych zamwie utworzone dla nich paczki zostay anulowane, maj status: Cancelled.');
            }

            return false;
        }

        return selected;
    }

    function paczkaLabelDialogOpen( e ){
        e.preventDefault();

        if ( !$labelDialog ) {
            $labelDialog = $('#paczkomatyLabelDialog').dialog( $.extend({},dialogOptions, {
                'title' : this.title,
                'width' : '650px',
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Drukuj",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $labelDialog.find('input[type=submit]').hide();
            $labelDialog.find('form').submit(paczkaGetSticker);
        }

        $labelDialog.data('zk', null);
        if ( $(this).hasClass('wydruk-btn')  ) {
            //pojedycze zamwienie
            $labelDialog.find('.zamowienia').html('').hide();
            zk = $(this).parents('tr').metadata(metadataOptions);
            $labelDialog.dialog('option', 'title', 'Wydruk etykiety paczki ' +zk.numer_przesylki + ' w PDFie' );

            if ( !zk.numer_przesylki ) {
                print_message('Dla wybranego zamwienia nie zostaa jeszcze utworzona paczka');
                return false;
            }

            if ( zk.przesylka_status == 'Cancelled' ) {
                print_message('Dla wybranego zamwienia paczka zostaa anulowana i etykieta nie moe zosta wydrukowana');
                return false;
            }

            $labelDialog.data('zk', zk);
        } else {
            if ( !zkPaczkiPrintCheck() ){
                return false;
            }

            $labelDialog.dialog('option', 'title', 'Wydruk etykiet paczek dla wybranych zamwie' );

            zkSelectedPrint($labelDialog.find('.zamowienia'), 'brak', '!Cancelled', true );
            $labelDialog.data('zk', null);
        }


        $labelDialog.find('.message_info, .message_notice, .message_error' ).hide();
        $labelDialog.dialog('enable');
        $labelDialog.dialog('open');

        return false;
    }
/**************************************************************************************************/


    function paczkiPrintoutDialogOpen( e ){
        e.preventDefault();

        if ( !$printoutDialog ) {
            $printoutDialog = $('#paczkomatyPrintoutDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Pobierz potwierdzenie nadania',
                'width' : '650px',
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Drukuj",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $printoutDialog.find('input[type=submit]').hide();
            $printoutDialog.find('form').submit(function(){
                var $form  = $(this);

                if ( !zkPaczkiPrintCheck(true) ){
                    return false;
                }

                $printoutDialog.find('.message_error' ).hide();

                zkSelection.appendTo(this, {
                    'field' : 'numer_przesylki',
                    'assoc' : true
                });

                showLoading();
                $printoutDialog.dialog('disable');
                $activeDialog = $printoutDialog;

                $form.ajaxSubmit($.extend({}, settingsAjax, {
                    'dataType':  'json',
                    'success': function(data){
                        if ( !zkPaczkiPrintCheck(true) ){
                            return false;
                        }

                        hideLoading();
                        $printoutDialog.dialog( "enable" );
                        $activeDialog = null;

                        if ( data && data.message ) {
                            print_message( data.message );

                            $printoutDialog.find('.message_' + data.message.type).html(data.message.body).slideDown();
                            $printoutDialog.find('.message_' + data.message.type + ' a').click(function(){
                                 $printoutDialog.dialog("close");
                             });

                             return;
                        }

                        if ( !data || !data.error ) {
                            $printoutDialog.dialog("close");
                        }
                    }
                }));

                return false;
            });
        }

        if ( !zkPaczkiPrintCheck(true) ){
            return false;
        }

        zkSelectedPrint($printoutDialog.find('.zamowienia'), 'brak', '!Cancelled', true);

        $printoutDialog.find('.message_info, .message_notice, .message_error' ).hide();
        $printoutDialog.dialog('enable');
        $printoutDialog.dialog('open');

        return false;
    }

/**********************************************************************************************************************/

    function zkPaczkiUpdateData( data, akcja ) {
        var errors = [];

        if ( data && data.length && data.length > 0 ) {
            var zk_numer, zk_id, zk, $zk_row, i, j, errors = [];

            for ( i = 0; i < data.length; i++ ) {
                zk_id = data[i].id;
                $zk_row = $('#zamowienie' + zk_id + '_row');

                if ( $zk_row.length && data.status ) {
                    $zk_row.find('.zk-status').html( data.status );

                    zk = $zk_row.metadata(metadataOptions);
                    zk.przesylka_status = zamowienie.przesylka.status;
                    $zk_row.attr('data', JSON.stringify(zk));

                    zk_numer = zk.numer;
                } else if( zkSelection.records && zkSelection.records[id] && zkSelection.records[id].numer ){
                    zk_numer = zkSelection.records[id].numer;
                }

                if ( data[i].error ) {
                    errors.push('Dla paczki <a href="#" title="">' + data.packcode + '</a> utworzonej do zamwienia'+( zk_numer ? ': <a href="">' + zk_numer + '</a>': '') + ( akcja ? ' nie udao si ' +akcja+' paczki, poniewa' : '' ) + ' wystapi bd: ' + data[i].error);
                }
            }
        }

        return errors;
    }

    function dialogPrintErrors( $dialog, errors, uwaga ) {
        if ( errors && errors.length ) {
            var error_message = uwaga ? uwaga : 'Uwaga! Wystpiy bdy: ';

            error_message += '<ul>';
            for ( i  = 0; i < errors.length; i++ ) {
                error_message += '<li>' + errors[i] + '</li>';
            }
            error_message += '<ul>';

            $dialog.find('.message_error' ).html(error_message).show();
        }
    }

    function paczkiPaymentSubmit(e){
        e.preventDefault();

        if ( !sprawdzWybraneZamowienia(true, 'Created', 'Opaci mona tylko paczki ze statusem Created') ){
            return false;
        }

        var $form  = $(this);

        var id, selected = [];
        for ( var i = 0; i < zkSelection.selected.length; i++ ) {
            id = zkSelection.selected[i];

            if ( this.records[id] && this.records[id]['numer_przesylki'] && this.records[id]['status'] == 'Created' ) {
                selected.push(id);
            }
        }

        zkSelection.appendTo(this, {
            'field' : 'numer_przesylki',
            'assoc' : true,
            'selected' : selected
        });

        showLoading();
        $paymentDialog.dialog('disable');
        $activeDialog = $paymentDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $paymentDialog.dialog( "enable" );

                print_message( data.message );

                //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                errors = zkPaczkiUpdateData(data.object, 'opaci');
                dialogPrintErrors($paymentDialog, errros, 'Uwaga! Podczas opacania paczek dla wybranych zamwie wystpiy bdy:');

                if ( !data.error ) {
                    $paymentDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }

    function paczkiPaymentDialogOpen( e ){
        if( e ) e.preventDefault();

        if ( !$paymentDialog ) {
            $paymentDialog = $('#paczkomatyPaymentDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Opa paczki',
                'width' : '650px',
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Opa",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $paymentDialog.find('input[type=submit]').hide();
            $paymentDialog.find('form').submit(paczkiPaymentSubmit);
        }

        if ( !sprawdzWybraneZamowienia(true, 'Created', 'Opaci mona tylko paczki ze statusem Created') ){
            return false;
        }
        $paymentDialog.find('.message_error' ).html('').hide();

        zkSelectedPrint($paymentDialog.find('.zamowienia'), 'brak', 'Created', true);
        $paymentDialog.dialog('open');

        return false;
    }

/**********************************************************************************************************************/

    function zkSelectedPrint( $div, paczka_warning, status, deselect, operacja ){
        $div.html('<h3>Wybrane zamwienia</h3>').show();
        var warnings = false, warning = '', r = null, $ul = $('<ol style="padding: 0; list-style-type:decimal" class="lista selected"></ol>');
        var lp = 1;
        for ( r in zkSelection.records ){
            warning = '';

            if ( paczka_warning ){
                if ( paczka_warning == 'jest' ){
                    if ( zkSelection.records[r].numer_przesylki && zkSelection.records[r].numer_przesylki != '' ) {
                        warning = 'Uwaga! Dla tego zamwienia zostaa ju stworzona paczka o numerze: ' + zkSelection.records[r].numer_przesylki + ' w systemie Paczkomaty 24/7';
                    }
                } else if ( paczka_warning == 'brak' ){
                    if ( !zkSelection.records[r].numer_przesylki || zkSelection.records[r].numer_przesylki == '' ) {
                        warning = 'Uwaga! Dla tego zamwienia nie zostaa utworzona paczka. ';
                    }
                }
            }

            if ( !warning ) {
                if ( status ) {
                    if ( status.substr(0,1) == '!' ) {
                        if ( zkSelection.records[r].przesylka_status && status.substr(1) == zkSelection.records[r].przesylka_status ) {
                            warning = 'Uwaga! Dla paczki o statusie ('+zkSelection.records[r].przesylka_status+') '+(operacja && operacja.przeprowadzona? operacja.przeprowadzona : 'operacja nie moe zosta przeprowadzona' )+'. Paczka zostanie pominita przy '+(operacja && operacja.wykonaniu? operacja.wykonaniu : 'wykonywaniu akcji' )+'.';
                        }
                   } else if ( !zkSelection.records[r].przesylka_status || zkSelection.records[r].przesylka_status != status ) {
                        warning = 'Uwaga! Status paczki ('+zkSelection.records[r].przesylka_status+') dla tego zamwienia jest inny ni wymagany do '+(operacja && operacja.przeprowadzenia ? operacja.przeprowadzenia : 'przeprowadzenia operacji' )+' ('+status+'). Paczka zostanie pominita przy '+(operacja && operacja.wykonaniu? operacja.wykonaniu : 'wykonywaniu akcji' )+'.';
                    }
                }
            }

            $ul.append( '<li class="rekord" >' +
                  ' <a class="zk-link" href="' + Paczkomaty.zk_info_url + r + '">' + zkSelection.records[r].numer + '</a>' +
                  ( deselect ? ' <a class="deselect" style="float: right" href="#" id="zkSelected' + r + '">Usu</a>' : '') +
                  ( warning ? ' <span class="warning" title="'+warning+'" style="float: right; vertical-align:middle">&nbsp;</span>' : '') +
                  '</li>' );

            if( warning ){
                warnings = true;
            }
        }

        $div.append($ul);
        $div.append('<div class="clear"></div>');

        if ( warnings || deselect ) {
            $ul.find('.warning').tooltip().button({
                'icons' : {
                    'primary' : 'ui-icon-alert'
                },
                'text' : false
            });

            if ( deselect ) {
                $ul.find('.deselect').button({
                    'icons' : {
                        'primary' : 'ui-icon-circle-minus'
                    },
                    'text' : false
                }).click(function(e){
                    e.preventDefault();

                    var matchid = $(this).attr('id') ? $(this).attr('id').match(/[0-9]+$/) : null;
                    if ( matchid ) {
                        zkSelection.remove(matchid[0]);
                    }

                    $(this).parent().fadeOut('slow', function(){
                        $(this).remove();
                    });

                    return false;
                });
            }

            $ul.find('.ui-icon').css('padding-bottom', '0');

            if ( paczka_warning == 'jest' ){
                print_message('Uwaga! dla czci wybranych zamwie paczka zostaa ju utworzona wczeniej i zamwienia te zostan pominite przy tworzeniu paczek. Sprawd ostrzeenia wywietlane przy numerze zamwienia.');
            }else if( paczka_warning == 'brak' ){
                print_message('Uwaga! dla czci wybranych zamwie paczka nie zostaa utworzona i zamwienia te zostan pominite. Sprawd ostrzeenia wywietlane przy numerze zamwienia.');
            }
        }

        $div.find('a.zk-link').click(zkLinkClick);
    }


/**************************************************************************************************/
    function paczkiCancelSubmit(e){
        e.preventDefault();
        var $form  = $(this);

        //jesli rwniez mam usunac paczki dla zamwien, to sprawdzam tlko czy sa zamwienia z paczkami i wysyam formularz
        if( $form[0].elements['zk_pack_delete'].checked ) {
            if ( !sprawdzWybraneZamowienia(true, null, 'Dla adnego z wybranych zamwie nie zostaa utworzona paczka') ){
                return false;
            }
        }else if ( !sprawdzWybraneZamowienia(true, 'Created', 'Anulowa mona tylko paczki ze statusem Created') ){
            return false;
        }


        zkSelection.appendTo(this, {
            'field' : 'numer_przesylki',
            'fields' : {
                'id' : 'zk_id',
                'numer_przesylki' : 'packcode',
                'przesylka_status' : 'status'
            },
            'assoc' : true
        });

        showLoading();
        $cancelDialog.dialog('disable');
        $activeDialog = $cancelDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $cancelDialog.dialog( "enable" );

                print_message( data.message );

                //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                if ( data.object ) {
                    var  errors = [], zk = null, $zk_row, i;

                    for ( i = 0; i < data.object.length; i++ ) {
                        $zk_row = $('#zamowienie' + (data.object[i] && data.object[i].zk_id ? data.object[i].zk_id : '') + '_row');

                        if ( data.object[i].statusDate && data.object[i].status ){
                            $zk_row.find('.przesylka-status').html( data.object[i].zk_status );
                        }

                        if ( data.object[i].error ) {
                            errors.push('Dla zamwienia ' + data.object[i].zk_numer + ' nie udao si anulowa/usun paczki, poniewa wystapi bd: ' + data.object[i].error );
                            continue;
                        }

                        if ( $zk_row.length ) {
                            zk = $zk_row.metadata(metadataOptions);
                            zk.numer_przesylki = '';
                            zk.przesylka_status = '';
                            $zk_row.attr('data', JSON.stringify(zk));
                        }

                        $zk_row.find('.paczka-btn').show();
                        $zk_row.find('.paczkomatEditBtn').show();
                        $zk_row.find('.wydruk-btn, .etykieta-btn').hide();

                        $zk_row.find('.przesylka-numer').html( '000000000000000000000000' );
                        $zk_row.find('.przesylka-status').html( 'Brak' );

                        if ( data.object[i] && data.object[i].zk_status ) {
                            $zk_row.find('.zk-status').html( data.object[i].zk_status );
                        }
                    }


                    if ( errors.length > 0 ) {
                        dialogPrintErrors($cancelDialog, errors, 'W trakcie anulowania/usuwania paczek dla zamwie wystapiy bdy:');
                    }
                }

                if ( !data.error ) {
                    $cancelDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }

    function paczkiCancelDialogOpen( e ){
        if( e ) e.preventDefault();

        if ( !$cancelDialog ) {
            $cancelDialog = $('#paczkomatyCancelDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Anuluj/Usu paczki dla zamwie',
                'width' : '650px',
                'buttons' : [
                    {
                        'text': "Zamknij",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Usu/Anuluj Paczki",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $cancelDialog.find('input[type=submit]').hide();
            $cancelDialog.find('form').submit(paczkiCancelSubmit);
        }

        $dialog.find('.message_error' ).html('').hide();

        if ( !sprawdzWybraneZamowienia(true, null, 'Nie mona anulowa/usun paczek, poniewa dla wybranych zamwie nie zostay utworzone paczki.') ){
            return false;
        }

        zkSelectedPrint($cancelDialog.find('.zamowienia'), 'brak', 'Created', true, {
            'przeprowadzenia' : 'anulowania paczki'
        });
        $cancelDialog.dialog('open');

        return false;
    }

/**************************************************************************************************/

    function paczkomaty_miasto_select( $select, miasto ) {
        if ( $select && $select.length > 0 && $select[0] && $select[0].options ) {
            $select[0].selectedIndex = 0;

            if( miasto ) {
                miasto = miasto.toString().toLowerCase();

                var m = '';
                for( var i = 0 ; i < $select[0].options.length; i++ ) {
                    m = $select[0].options[i].text ? $select[0].options[i].text.toLowerCase() : '';
                    if ( m == miasto ) {
                        $select[0].selectedIndex = i;
                        //$select.val(i-1);
                        break;
                    }
                }
            }
        }
    }

    function paczkomaty_options ( params, $paczkomat_select ) {

        if ( typeof(Paczkomaty.machines) != 'object') {
            return false;
        }

        var default_params = {
            'payment' : false,
            'nearest' : false,
            'customer' : Paczkomaty.customer,
            'postcode_machines' : Paczkomaty.postcode_machines,
            'miasto': '',
            'postcode' : null
        };

        if ( typeof(params.customer) != 'undefined'  ) {
            Paczkomaty.customer = params.customer;
        }

        if ( typeof(params.customer) != 'undefined'  ) {
            Paczkomaty.postcode_machines = params.postcode_machines;
        }

        params = $.extend({}, default_params, params ? params : {});

        if ( params.nearest && params.selected ){
            params.selected = null;
        }

        //zabiezpieczenie dla pierwszej opcji
        if ( params.miasto == 'Wybierz' ) {
            params.miasto = '';
        }

        //console.log('inpost_paczkomaty_options(' + inpost_obj2str(params) + ')');
        var m, machines = [], i = 0;
        if ( params.payment || params.miasto ) {
            for ( m in Paczkomaty.machines ) {
                if ( (!params.miasto || params.miasto == Paczkomaty.machines[m].town) &&  (!params.payment || Paczkomaty.machines[m].paymentavailable ) ) {
                    machines.push(Paczkomaty.machines[m]);
                }
            }
        } else {
            for ( m in Paczkomaty.machines ) {
                machines.push(Paczkomaty.machines[m]);
            }
        }

        var machines_assoc = new Object();
        for ( i = 0; i < machines.length; i++ ) {
            machines_assoc[machines[i].name] = machines[i];
        }

        var opcja = null;

        if( !$paczkomat_select || $paczkomat_select.length == 0 ) {
            $paczkomat_select = $('#zkPaczkomatName');
        }
        $paczkomat_select.children('option').remove();
        $paczkomat_select.append(new Option('Wybierz', ''));

        var customer_options = false;
        if ( params.customer ) {
            if ( params.customer.preferedBoxMachineName && machines_assoc[params.customer.preferedBoxMachineName] ) {
                opcja = new Option('Paczkomat domylny', 'default');
                opcja.setAttribute('disabled', 'disabled');
                opcja.setAttribute('style', 'font-weight: bold');
                $paczkomat_select.append(opcja);

                opcja = new Option(machines_assoc[params.customer.preferedBoxMachineName]['name_str'], machines_assoc[params.customer.preferedBoxMachineName]['name'])
                //jesli nie ma zaznaczonego
                if ( !params.selected || (params.selected == params.customer.preferedBoxMachineName) ) {
                    opcja.setAttribute('selected', 'selected');

                    params.selected = null
                }
                $paczkomat_select.append(opcja);

                customer_options = true;
            }

            if ( params.customer.alternativeBoxMachineName && machines_assoc[params.customer.alternativeBoxMachineName] ) {
                opcja = new Option('Paczkomat alternatywny', 'alt');
                opcja.setAttribute('disabled', 'disabled');
                opcja.setAttribute('style', 'font-weight: bold');
                $paczkomat_select.append(opcja);

                opcja = new Option(machines_assoc[params.customer.alternativeBoxMachineName]['name_str'], machines_assoc[params.customer.alternativeBoxMachineName]['name'])
                if ( params.selected && params.selected == params.customer.alternativeBoxMachineName ) {
                    opcja.setAttribute('selected', 'selected');
                    params.selected = null;
                }

                $paczkomat_select.append(opcja);

                customer_options = true;
            }
        }

        var postcode_options = false;
        if ( params.postcode && params.postcode_machines ) {
            for ( m in params.postcode_machines ) {
                if ( typeof(params.postcode_machines[m]) != 'object' ){
                    continue;
                }
                machine = params.postcode_machines[m];

                if ( !postcode_options ) {
                    opcja = new Option('Paczkomaty najbliej kodu ' + params.postcode, 'postcode');
                    opcja.setAttribute('disabled', 'disabled');
                    opcja.setAttribute('style', 'font-weight: bold');
                    if ( params.nearest ) {
                        opcja.setAttribute('selected', 'selected');
                    }
                    $paczkomat_select.append(opcja);

                    postcode_options = true;
                }

                opcja = new Option(machine['name_str'], machine['name']);
                if ( params.selected && params.selected == machine.name ) {
                    opcja.setAttribute('selected', 'selected');
                    params.selected = null;
                }

                $paczkomat_select.append(opcja);
            }
        }

        if ( postcode_options || customer_options ) {
            opcja = new Option('Wszystkie paczkomaty', '');
            opcja.setAttribute('disabled', 'disabled');
            opcja.setAttribute('style', 'font-weight: bold');
            $paczkomat_select.append(opcja);
        }

        for ( i = 0; i < machines.length; i++ ) {
            opcja = new Option(machines[i].name_str, machines[i].name);

            if ( params.selected && params.selected == machines[i].name ) {
                opcja.setAttribute('selected', 'selected');
                params.selected = null;
            }

            $paczkomat_select.append(opcja);
        }

        $paczkomat_select.triggerHandler('change');
    }

    function _str2obj( data ){
        if ( typeof(data) === 'string' ) {
            if( data.substr(0,1) === '{' && data.substr(data.length-1) === '}' ){
                try{
                    data = eval('(' + data + ')');
                }catch(e){
                    data = null;
                }
            }
        }

        return data;
    }

    var paczkomaty_find_busy = false;
    function paczkomaty_find ( params, $select ) {
        var cache = false;

        if ( paczkomaty_find_busy ) {
            setTimeout(function(){
                paczkomaty_find(params, $select);
            }, 1000);

            return;
        }

        if ( typeof(params.payment) == 'undefined' ){
            params.payment = false;
        }

        if ( params.email && (typeof(params.email) !='string' || !params.email.match(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i)) ) {
             params.email = '';
        }

        if ( params.email ) {
            params.email = params.email.toLocaleLowerCase();

            if ( typeof(Paczkomaty.cache.emails[params.email]) == 'object' ) {
                params.customer = Paczkomaty.cache.emails[params.email];
                cache = true;
            }
        }

        if ( params.postcode && (typeof(params.postcode) !='string' || !params.postcode.match(/^[0-9]{2}-[0-9]{3}$/)) ) {
            params.postcode = '';
        }

        if ( params.postcode ) {
            if ( params.payment ) {
                if ( typeof(Paczkomaty.cache.postcodes1[params.postcode]) != 'undefined' ) {
                    params.postcode_machines = Paczkomaty.cache.postcodes1[params.postcode];
                    cache = true;
                }
            } else {
                if ( typeof(Paczkomaty.cache.postcodes0[params.postcode]) != 'undefined' ) {
                    params.postcode_machines = Paczkomaty.cache.postcodes0[params.postcode];
                    cache = true;
                }
            }
        }

        if ( cache ) {
            paczkomaty_options(params, $select);

            return;
        }

        if ( params.email || params.postcode ) {
            paczkomaty_find_busy = true;

            $.get( MAIN_URL  + '?action=inpost&mode=paczkomaty&ajax=1', params, function ( d ){
                paczkomaty_find_busy = false;

                try{
                    data = _str2obj(d);

                    if ( params.email ) {
                        params.customer = data.object.customer;
                        Paczkomaty.cache.emails[params.email] = data.object.customer;
                    }

                    if ( params.postcode ) {
                        params.postcode_machines = data.object.machines;

                        if ( params.payment ) {
                            Paczkomaty.cache.postcodes1[params.postcode] = data.object.machines;
                        } else {
                            Paczkomaty.cache.postcodes0[params.postcode] = data.object.machines;
                        }
                    }
                }catch(e){
                    console.log(e);
                    params.postcode_machines = params.customer = null;
                    Paczkomaty.customer = Paczkomaty.postcode_machines = null;
                }

                paczkomaty_options(params, $select);
            });
        } else if( params ) {
            paczkomaty_options(params, $select);
        }
    }

    function paczkomaty_callback(value) {
        var arrEasyPackData = value.split(';');

        if ( $paczkomatMapBtn ) {
            $($paczkomatMapBtn.attr('href')).val(arrEasyPackData[0]);
        }
    }


    function zkPaczkomatSave() {
        var $form  = $(this);

        var $paczkomat = $form.find('select[name=paczkomat]');
        var paczkomat = $paczkomat.val();
        if ( !paczkomat ) {
            print_message( 'Wybierz paczkomat jaki chcesz ustawi dla zamwienia');
            return false;
        }
        var pack_size = $form.find('select[name=pack_size]').val();

        showLoading();
        $zkPaczkomatDialog.dialog('disable');
        $activeDialog = $zkPaczkomatDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $zkPaczkomatDialog.dialog( "enable" );

                print_message( data.message );

                //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                if ( !data.error && data.type!='error' ) {
                    var zk_id = $form.find('input[name=zk_id]').val();
                    var $zk_row = $('#zamowienie' + zk_id + '_row');

                    if ( $zk_row.length ) {
                        $zk_row.find('.zk-paczkomat').html( paczkomat + ( pack_size ? ':' + pack_size : '') );

                        var zk = $zk_row.metadata(metadataOptions);
                        var zki = zk ? zk.index : ($zk_row.index() - 1);
                        Paczkomaty.zamowienia[zki].PACK_SIZE = pack_size;
                    }
                }

                if ( !data.error ) {
                    $zkPaczkomatDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }

    function zk_paczkomat_params(){
        var params = {};

        if ( $('#zkPaczkomatEmail').val() ){
            params.email = $('#zkPaczkomatEmail').val();
        }

        if ( $('#zkPaczkomatPostcode').val() ){
            params.postcode = $('#zkPaczkomatPostcode').val();
        }

        params.payment = $('#zkPaczkomatPobranie').is('checked') ? true : false;
        params.miasto =  $('#zkPaczkomatMiasto').find("option:selected").text();

        return params;
    }


    function zkPaczkomatOpen( e ){
        e.preventDefault();

        var $this = $(this);
        if ( !$zkPaczkomatDialog ) {
            $zkPaczkomatDialog = $('#zkPaczkomatDialog').dialog( $.extend({}, dialogOptions, {
                'title' : this.title,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zmie",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() { $(this).find("form").submit();}
                    }
                ]
            }));

            $zkPaczkomatDialog.find('#zkPaczkomatName').css({'width' : '300px'});

            $zkPaczkomatDialog.find('input[type=submit]').hide();
            $zkPaczkomatDialog.find('#zkPaczkomatMiasto').change(function(){
                paczkomaty_options(zk_paczkomat_params());
            });

            $zkPaczkomatDialog.find('#zkPaczkomatEmail').change(function(){
                paczkomaty_find(zk_paczkomat_params());
            });

            $zkPaczkomatDialog.find('#zkPaczkomatPobranie').click(function(){
                paczkomaty_find(zk_paczkomat_params());
            });

            $zkPaczkomatDialog.find('#zkPaczkomatPostcode').change(function(){
                paczkomaty_find(zk_paczkomat_params());
            });

            $zkPaczkomatDialog.find('.jquery-tabs').tabs();
            $zkPaczkomatDialog.find('.jquery-tabs ul').css('width', 'auto');
            $zkPaczkomatDialog.find('form').submit(zkPaczkomatSave);
        }

        var zki, zk = $this.parents('tr').metadata(metadataOptions);
        if ( !zk ) {
            zki = $this.parents('tr').index() - 1;
            zk = $.extend({}, Paczkomaty.zamowienia[zki]);
        } else {
            zk = $.extend({}, Paczkomaty.zamowienia[zk.index]);
        }

        Paczkomaty.postcode_machines = Paczkomaty.customer = null;

        if ( zk ) {
            var $form = $zkPaczkomatDialog.find('form');
            $form.find('select[name=pack_size]').val('');

            var data = {
                'email' : zk.EMAIL,
                'postcode' : '',
                'miasto' : '',
                'pack_size' : zk.PACK_SIZE,
                'paczkomat' : zk.PACZKOMAT
            };

            if ( zk.DOSTAWA_KOD_POCZTOWY ) {
                data.postcode = zk.DOSTAWA_KOD_POCZTOWY;
            } else if ( zk.KOD_ODBIORCY ) {
                data.postcode = zk.KOD_ODBIORCY;
            } else if ( zk.KOD_PLATNIKA ){
                data.postcode = zk.KOD_PLATNIKA;
            }

            formSetValues ( $form[0], data );

            przesylkaZamowienieInfo(zk, 'zkPaczkomatZamowienieSzablon', 'zkPaczkomatZamowienie');
        }


        $zkPaczkomatDialog.find('input[name=zk_id]').val(paczkomaty_find_id(this.id));
        $zkPaczkomatDialog.dialog('option', 'title', this.title);
        $zkPaczkomatDialog.dialog('open');

        return false;
    }

    function paczkomaty_find_id( str, regexp ) {
        if ( !regexp ){
            regexp = /-([0-9]+)$/;
        }

        var m = str.match(regexp);
        if ( m && m.length ){
            return m[1];
        }

        return 0;
    }


/**************************************************************************************************/

    function templateOptions() {
        var $select = $paczkaDialog.find('select[name=szablon]');
        var option = null, update = false;

        if( !Paczkomaty.template_options ){
            Paczkomaty.template_options = [];
        }

        if ( Paczkomaty.templates && (!Paczkomaty.template_options || Paczkomaty.template_options.length == 0) ) {
            Paczkomaty.options = [];

            for ( var o in Paczkomaty.templates ) {
                if( typeof(Paczkomaty.templates[o]) == 'object' ){
                    Paczkomaty.template_options.push(o) ;
                }
            }

            update = true;
        }

        if ( !$select.val() ) {
            option = $paczkaDialog.find('input[name=template]').val();
        }

        if ( option ) {
            var dodaj_opcje = true;
            for ( var i = 0; i < Paczkomaty.template_options.length ; i++ ) {
                if ( Paczkomaty.template_options[i] == option ) {
                    dodaj_opcje = false;
                    break;
                }
            }

            if( dodaj_opcje ){
                Paczkomaty.template_options.push(option);
            }

            update = true;
        }

        if ( update ) {
            $select.children('option:gt(0)').remove();

            Paczkomaty.template_options.sort();
            for ( var i = 0; i < Paczkomaty.template_options.length ; i++ ) {
                $select.append('<option value="' + Paczkomaty.template_options[i]+ '">' + Paczkomaty.template_options[i] + '</option>');
            }
        }
    }

    function templateDelete( ){
        var tpl = $paczkaDialog.find('select[name=szablon]').val();

        if ( !tpl ) {
            print_message( 'Wybierz szablon przesyki ktry chcesz usun' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': Paczkomaty.url,
            'dataType':  'json',
            'data':  {'mode' : 'template', 'delete' : tpl},

            'success': function(data) {
                hideLoading();
                $paczkaDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error && tpl && Paczkomaty.templates[tpl] ) {
                    delete Paczkomaty.templates[tpl];
                    Paczkomaty.template_options = [];
                    templateOptions();
                }
            }
        }));

        return false;
    }



    function przesylkaUpdateStacjaOdbioru( placowka ){
        if ( placowka && placowka.symbol ){
            $paczkaDialog.find('input[name=odb]').val(placowka.symbol);
        }
    }

    function przesylkaUpdateStacjaNadania( placowka ){
        if ( placowka && placowka.symbol ){
            $paczkaDialog.find('input[name=nad]').val(placowka.symbol);
        }
    }

    var szablonChangeBusyState = false;
    function szablonOnChange( e ){
        if ( szablonChangeBusyState ){
            return;
        }
        szablonChangeBusyState = true;

        var data = {}, val = this.value, options = $paczkaDialog.data('options');

        if ( options.zamowienie && options.zamowienie.id ) {
            przesylkaZamowienieData( options.zamowienie.id, val );
        } else{
            if ( this.value && Paczkomaty.templates[this.value] ) {
                data = Paczkomaty.templates[this.value];
            }

            formSetValues(this.form, data, { 'clear' : true });

            this.value = val;
        }

        szablonChangeBusyState = false;

        paczkaTriggerHandlers();

        return true;
    }

    var przesylkaZamowienieDataBusyState = false;
    function przesylkaZamowienieData ( id, template ) {
        if ( przesylkaZamowienieDataBusyState ){
            return;
        }

        if ( id > 0 && typeof(template) == 'string' && template != '' ){
            przesylkaZamowienieDataBusyState = true;

            $activeDialog = $paczkaDialog;
            $paczkaDialog.dialog('disable');

            $.ajax($.extend({}, settingsAjax, {
                'url': Paczkomaty.url,
                'dataType':  'json',
                'data':  {
                    'mode' : 'przesylka',
                    'id' : id,
                    'template' : template
                },

                'success': function(data) {
                    hideLoading();
                    $paczkaDialog.dialog( "enable" );
                    przesylkaZamowienieDataBusyState = false;

                    print_message( data );

                    if ( !data.error ) {
                        var $form = $paczkaDialog.find('form');
                        formSetValues( $form[0], data.object.przesylka, { 'clear' : $form.find('input,select').not('[name=szablon]').not('[type=hidden]') } );

                        przesylkaZamowienieInfo(data.object.zamowienie);

                        paczkaTriggerHandlers();
                    }
                }
            }));
        }
    }

    function przesylkaZamowienieInfo( zk, tpl, dst ){
        if ( !tpl ){
            tpl = 'paczkomatyPaczkaZkTemplate';
        }

        if ( !dst ) {
            dst = 'paczkomatyPaczkaZamowienie'
        }

        var html = '<div class="head">Informacja o zamwieniu</div>';

        zk.PLN_WARTOSC_NETTO  = currency_format(zk.PLN_WARTOSC_NETTO);
        zk.PLN_WARTOSC_BRUTTO  = currency_format(zk.PLN_WARTOSC_BRUTTO);

        zk.adres = {
            'kod' : '',
            'miasto' : '',
            'ulica' : '',
            'nrDom' : '',
            'nrLokal' : ''
        };

        if ( zk.DOSTAWA_KOD_POCZTOWY && zk.DOSTAWA_ULICA && zk.DOSTAWA_MIEJSCOWOSC ) {
            zk.adres.kod = zk.DOSTAWA_KOD_POCZTOWY;
            zk.adres.miasto = zk.DOSTAWA_MIEJSCOWOSC;
            zk.adres.ulica = zk.DOSTAWA_ULICA;
            zk.adres.nrDom = zk.DOSTAWA_NR_DOMU;
            zk.adres.nrLokal = zk.DOSTAWA_NR_LOKALU;
        } else if ( zk.KOD_ODBIORCY && zk.MIEJSCOWOSC_ODBIORCY && zk.ULICA_ODBIORCY) {
            zk.adres.kod = zk.KOD_ODBIORCY;
            zk.adres.miasto = zk.MIEJSCOWOSC_ODBIORCY;
            zk.adres.ulica = zk.ULICA_ODBIORCY;
            zk.adres.nrDom = zk.NRDOMU_ODBIORCY;
            zk.adres.nrLokal = zk.NRLOKALU_ODBIORCY;
        } else if ( zk.KOD_PLATNIKA && zk.MIEJSCOWOSC_PLATNIKA && zk.ULICA_PLATNIKA ){
            zk.adres.kod = zk.KOD_PLATNIKA;
            zk.adres.miasto = zk.MIEJSCOWOSC_PLATNIKA;
            zk.adres.ulica = zk.ULICA_PLATNIKA;
            zk.adres.nrDom = zk.NRDOMU_PLATNIKA;
            zk.adres.nrLokal = zk.NRLOKALU_PLATNIKA;
        }

        html += print_object( (tpl.substr(0,1) != '#' ? '#' : '') + tpl, zk );
        $((dst.substr(0,1) != '#' ? '#' : '') + dst).html( html ).slideDown();
    }

    function przesylkiZamowieniaHTML( $zamowienia ) {
        $zamowienia.html('<div class="head">Wybrane zamwienia</div>').show();

        if ( zkSelection.selected.length > 0 ) {
            var warning, warnings = false, r = null;

            var $ul = $('<ol class="lista"></ol>');
            for ( r in zkSelection.records ){
                warning = '';
                if ( zkSelection.records[r].numer_przesylki && zkSelection.records[r].numer_przesylki != '' ) {
                    warning = 'Uwaga! Dla tego zamwienia zostaa ju stworzona przesyka o numerze: ' + zkSelection.records[r].numer_przesylki + ' w systemie Paczkomaty 24/7';
                }

                $ul.append( '<li class="item zk-numer">' + zkSelection.records[r].numer + ( warning ? ' <span class="warning" title="'+warning+'" style="float: none; vertical-align:middle">&nbsp;</span>' : '') + '</li>' );

                if ( warning ) warnings = true;
            }

            $zamowienia.append($ul);

            if ( warnings ) {
                $ul.find('.warning').tooltip().button({
                    'icons' : {
                        'primary' : 'ui-icon-alert'
                    },
                    'text' : false
                });

                print_message('Uwaga dla czci wybranych zamwie przesyka paczka zostaa stworzona wczeniej i zostan pominite przy tworzeniu paczek. Sprawd ostrzeenia wywietlane przy numerze zamwienia.');
            }
        } else {
            sprawdzWybraneZamowienia();
        }
    }

    function paczkaSenderClick(){
        //console.log('paczkaSenderClick');
        if ( this.checked ) {
            $paczkaDialog.find('input[name^=senderAddress]').removeAttr('disabled', 'disabled').removeClass('disabled');
        } else {
            $paczkaDialog.find('input[name^=senderAddress]').attr('disabled', 'disabled').addClass('disabled');
        }
    }

    function paczkaPaczkomatParams() {
        var params = {};

        if ( $('#paczkomatyPaczkaEmail').val() ){
            params.email = $('#paczkomatyPaczkaEmail').val();
        }

        if ( $('#paczkomatyPaczkaPostcode').val() ){
            params.postcode = $('#paczkomatyPaczkaPostcode').val();
        }

        params.payment = $('#paczkomatyPaczkaPobranie').is('checked') ? true : false;
        params.miasto  =  $('#paczkomatyPaczkaMiasto')[0].selectedInde > 0 ? $('#paczkomatyPaczkaMiasto').find("option:selected").text() : '';
        params.selected =  $('#paczkomatyPaczkaName').val();

        return params;
    }

    function przesylkaOpen ( e ) {
        e.preventDefault();

        var options = {};
        var $this = $(this);

        options.template = this.id.indexOf('Szablon') > -1;
        options.multiple = this.id.indexOf('Przesylki') > -1;
        options.zamowienie = {};

        Paczkomaty.customer = null;
        Paczkomaty.postcode_machines = null;

        if ( !options.multiple && !options.template ) {
            options.zamowienie = $this.parents('tr').metadata(metadataOptions);
        }

        if ( !$paczkaDialog ) {
            $paczkaDialog = $('#paczkomatyPaczkaDialog').dialog( $.extend({},dialogOptions, {
                'maxWidth': 1100,
                'width' : 900,
                'minHeight': 650,
                'height' : 700
            }));

            $paczkaDialog.find( "#paczkomatyPaczkaTabs" ).tabs();
            $paczkaDialog.find( "#paczkomatyPaczkaTabs ul" ).css('width', 'auto');

            $paczkaDialog.find('input[type=submit]').hide();

            $('#paczkomatyPaczkaSzablon').change( szablonOnChange );
            $('#paczkomatyPaczkaSender').click( paczkaSenderClick ).triggerHandler('click');

            $paczkaDialog.find('.pack-size').click(function(e){
                e.preventDefault();
                $(this).parent().find('input').click();
                return false;
            });

            $paczkaDialog.find('form').submit(paczkaSend);

            if ( Paczkomaty.sender && Paczkomaty.sender.postcode && Paczkomaty.sender.email ) {
                paczkomaty_options({
                    'email' : Paczkomaty.sender.email,
                    'postcode' : Paczkomaty.sender.postcode,
                    'customer' : Paczkomaty.sender.customer,
                    'postcode_machines'  : Paczkomaty.sender.postcode_machines
                }, $('#paczkaSenderBoxMachineName'));
            } else {
                paczkomaty_options({}, $('#paczkaSenderBoxMachineName'));
            }

            $('#paczkomatyPaczkaEmail').change(function(){
                paczkomaty_find(paczkaPaczkomatParams(), $('#paczkomatyPaczkaName'));
            });

            $('#paczkomatyPaczkaPostcode').change(function(){
                paczkomaty_find(paczkaPaczkomatParams(), $('#paczkomatyPaczkaName'));
            });

            $('#paczkomatyPaczkaPobranie').click(function(){
                paczkomaty_find(paczkaPaczkomatParams(), $('#paczkomatyPaczkaName'));
            });

            $('#paczkomatyPaczkaName').change(function(){
                if ( this.value ) {
                    $('#paczkomatyPaczkaStacjaOdbioru').val(this.value );
                } else {
                    $('#paczkomatyPaczkaStacjaOdbioru').val( 'XXX000');
                }
            });

            $('#paczkaSenderBoxMachineName').change(function(){
                if ( this.value ) {
                    $('#paczkomatyPaczkaStacjaNadania').val( this.value );
                } else {
                    $('#paczkomatyPaczkaStacjaNadania').val( 'XXX000');
                }
            });

            $('#paczkomatyPaczkaPayOnDelivery').click(function(){
                if( !this.checked ) {
                    $('#paczkomatyPaczkaOnDeliveryAmount').addClass('disabled').attr('disabled', 'disabled')
                } else {
                    $('#paczkomatyPaczkaOnDeliveryAmount').removeClass('disabled').removeAttr('disabled', 'disabled');
                }
            }).click();

            $('#paczkaCustomerDelivering').change(function(){
                $('#senderBoxMachine').hide();
                //$('#senderBoxMachine select').attr('disabled', 'disabled');
                $('#paczkaSendTerminal').hide();
                $('#paczkomatyPaczkaStacjaOdbioru').val( 'XXX000');

                if ( this.value == 'EASYPACK' ) {
                    $('#senderBoxMachine').show();
                    $('#senderBoxMachine select').removeAttr('disabled').triggerHandler('change');
                } else if ( this.value == 'DEPARTMENT'  ) {
                    //w oddziale
                } else if ( this.value == 'TERMINAL'  ) {
                    $('#paczkaSendTerminal').show();
                }
            }).change();

            templateOptions();
        }

/**************************************************************************************************/

        if( Paczkomaty.config &&  Paczkomaty.settings && Paczkomaty.settings[Paczkomaty.config] && Paczkomaty.settings[Paczkomaty.config].szablon ){
            var szablon = Paczkomaty.settings[Paczkomaty.config].szablon;

            if ( Paczkomaty.templates && typeof(Paczkomaty.templates[szablon]) == 'object' ){
                if ( $('#paczkomatyPaczkaSzablon').val() != szablon ) {
                    $('#paczkomatyPaczkaSzablon').val( szablon );
                }
            }
        }

/**************************************************************************************************/
        var przesylkaOptions = {
            'title' : this.title
        };

        przesylkaOptions.buttons = [];
        przesylkaOptions.buttons = [
            {
                'text': "Anuluj",
                'icons' : {'primary' : 'ui-icon-cancel'},
                'click': function() {$(this).dialog("close");}
            }
        ];

        if ( options.template ) {
            przesylkaOptions.buttons.push({
                'text': "Usu",
                'icons': {primary : 'ui-icon-trash'},
                'click': templateDelete
            });

            przesylkaOptions.buttons.push({
                'text': "Zapisz",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {$(this).find("form").submit();}
            });
        } else {
            przesylkaOptions.buttons.push({
                'text': "Opa i wylij",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {
                    $(this).find("input[name=autoLabels]").val('1');
                    $(this).find("form").submit();
                }
            });

            przesylkaOptions.buttons.push({
                'text': "Przygotuj",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {
                    $(this).find("input[name=autoLabels]").val('0');
                    $(this).find("form").submit();
                }
            });
        }

        $paczkaDialog.dialog('option', przesylkaOptions );
        $paczkaDialog.data('options', options);

/**************************************************************************************************/

        if ( options.zamowienie && options.zamowienie.id ) {
            var zki = options.zamowienie.index;

            if ( Paczkomaty.zamowienia[zki] ) {
                var $form = $paczkaDialog.find('form');
                var tpl = $('#paczkomatyPaczkaSzablon').val();

                if ( tpl && (!Paczkomaty.zamowienia[zki].paczka || !Paczkomaty.zamowienia[zki].paczka.template || Paczkomaty.zamowienia[zki].paczka.template != tpl) ) {
                    przesylkaZamowienieData(options.zamowienie.id, tpl );
                } else {
                    var $fields = $form.find('input,select').not('[type=hidden]').not('[name=szablon]');

                    //tworze nowy obiekt bo sa problemy jak konwertuje wartosc zamwienia
                    var zk = $.extend( {}, Paczkomaty.zamowienia[zki]);

                    var paczka = null;
                    if ( Paczkomaty.zamowienia[zki].paczka ){
                        paczka = Paczkomaty.zamowienia[zki].paczka;
                    } else {
                        paczka = {
                            'adreseeEmail' : Paczkomaty.zamowienia[zki].EMAIL,
                            'senderEmail' : Paczkomaty.api.email,
                            'phoneNum' : Paczkomaty.zamowienia[zki].TEL,
                            'boxMachineName' : Paczkomaty.zamowienia[zki].PACZKOMAT,
                            'alternativeBoxMachineName' : Paczkomaty.zamowienia[zki].PACZKOMAT_ALT,
                            'packType' : 'B',
                            'sendType' : 'DEPARTMENT',
                            'insuranceAmount' : '0',
                            'onDeliveryAmount' : '',
                            'customerRef' : Paczkomaty.zamowienia[zki].NUMER,
                            'senderBoxMachineName' : '',
                        };

                        if ( zk.DOSTAWA_KOD_POCZTOWY ) {
                            paczka.postcode = zk.DOSTAWA_KOD_POCZTOWY;
                        } else if ( zk.KOD_ODBIORCY ) {
                            paczka.postcode = zk.KOD_ODBIORCY;
                        } else if ( zk.KOD_PLATNIKA ){
                            paczka.postcode = zk.KOD_PLATNIKA;
                        }

                        if ( zk.DOSTAWA_MIEJSCOWOSC ) {
                            paczka.place = zk.DOSTAWA_MIEJSCOWOSC;
                        } else if ( zk.MIEJSCOWOSC_ODBIORCY ) {
                            paczka.place = zk.MIEJSCOWOSC_ODBIORCY;
                        } else if ( zk.MIEJSCOWOSC_PLATNIKA ){
                            paczka.place = zk.MIEJSCOWOSC_PLATNIKA;
                        }
                    }

                    formSetValues ( $form[0], paczka, { 'clear' : $fields } );
                    if ( paczka.place ) {
                        paczkomaty_miasto_select( $('#paczkomatyPaczkaMiasto'), paczka.place);
                    }
                    paczkaTriggerHandlers();


                    przesylkaZamowienieInfo( zk, 'paczkomatyPaczkaZkTemplate', 'paczkomatyPaczkaZamowienie' );
                    print_message('Wybierz szablon przesyki aby utworzy przesyk wedug zapsanego schematu, albo wypenij samodzielnie dane do przesyki.');
                }
            }
        } else {
            $('#paczkomatyPrzesylkaZamowienie').hide().html('');
            $('#paczkomatyPaczkaSzablon').triggerHandler('change');
        }

        if ( options.multiple || options.template ){
            if ( options.template ) {
                $paczkaDialog.find('.template0').hide();
                $paczkaDialog.find('.template1').show();
            } else {
                $paczkaDialog.find('.template0').not('.multi0').show();
                $paczkaDialog.find('.template1').hide();
            }

            if ( options.multiple ){
                $paczkaDialog.find('.multi0').hide();
            } else {
                $paczkaDialog.find('.multi0').not('.template0').show();
            }
        } else {
            $paczkaDialog.find('.template0, .multi0').show();
            $paczkaDialog.find('.template1, .multi1').hide();

            $('#paczkomatyPaczkaTemplate').hide();
        }

        var $zamowienia = $paczkaDialog.find('.zamowienia');
        if ( options.multiple ) {
            if ( !sprawdzWybraneZamowienia('brak') ) {
                return false;
            }

            zkSelectedPrint( $zamowienia, 'jest');
        } else {
            $zamowienia.html('').hide();
        }

        //czyszcze box z bdami
        $paczkaDialog.find('#paczkomatyPaczkaErrors').html('').hide();
        $paczkaDialog.dialog('open');

        return false;
    }

    function paczkaTriggerHandlers(){
        $('#paczkomatyPaczkaPostcode').triggerHandler('change');
        $('#paczkaCustomerDelivering').triggerHandler('change');
        $('#paczkomatyPaczkaName').triggerHandler('change');
        $('#paczkomatyPaczkaPayOnDelivery').triggerHandler('click');
        $('#paczkomatyPaczkaSender').triggerHandler('click');
    }

    function przesylkiCheckZamowienia( form ) {
        if ( !sprawdzWybraneZamowienia() ) {
            return false;
        }

        var items = [];
        for ( r in zkSelection.records ){
            if ( !zkSelection.records[r].numer_przesylki || zkSelection.records[r].numer_przesylki == '' ) {
                items.push( r );
            }
        }

        if ( items.length == 0 ) {
            print_message('Nie mona wysa formularza poniewa dla wybranych zamwie paczki zostay ju utworzone');
            return false;
        }

        zkSelection.appendTo(form, {'selected' : items} );

        return true;
    }

    function paczkaSend() {
        var options = $paczkaDialog.data('options');
        var $form  = $(this);

        //czyszcze box z bdami
        $paczkaDialog.find('#paczkomatyPaczkaErrors').html('').hide();

        if ( options.template ){
            $( 'input[name=mode]', this ).val( 'template' );
        } else if ( options.zamowienie && options.zamowienie.id ){
            $( 'input[name=mode]', this ).val( 'przesylka' );
        } else {
            $( 'input[name=mode]', this ).val( 'przesylki' );
        }

        if ( options.multiple ){
            if ( !przesylkiCheckZamowienia(this) ) {
                return false;
            }
        } else if ( options.zamowienie ){
           $form.find('input[name^=selected]').remove();
           $form.append('<input type="hidden" name="selected[]" value="' + options.zamowienie.id + '" />');
        }

        var $status = $('#paczkomatyPrzesylkaOpcjeZamowienieStatus');
        var status_id = $status.val(), status = null;
        if ( status_id ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        }

        showLoading();
        $paczkaDialog.dialog('disable');
        $activeDialog = $paczkaDialog;

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $paczkaDialog.dialog( "enable" );

                print_message( data.message );

                if ( options.template ){
                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        var template = data.object;
                        if ( !Paczkomaty.templates ){
                            Paczkomaty.templates = new Object();
                        }
                        Paczkomaty.templates[template.template] = template;

                        //aktualizuje opcje dla template
                        templateOptions();

                        $paczkaDialog.dialog("close");
                        $activeDialog = null;
                    }
                } else {
                    if ( data.object && data.object.length ) {
                        var zamowienie = null, errors = [];

                        for( var i = 0; i < data.object.length; i++ ){
                            zamowienie = data.object[i];

                            if ( zamowienie.przesylka ) {
                                $zk_row = $('#zamowienie' + zamowienie.ID + '_row');

                                if ( $zk_row.length ) {
                                    zk = $zk_row.metadata(metadataOptions);
                                    zk.numer_przesylki = zamowienie.przesylka.packcode;
                                    zk.przesylka_status = zamowienie.przesylka.status;
                                    $zk_row.attr('data', JSON.stringify(zk));

                                    //ustawiam paczk aby dao si wyswietli informacje o utworzonej paczce po kliknieciu na przycisk info
                                    if ( zamowienie.paczka && Paczkomaty.zamowienia[zk.index] ){
                                        Paczkomaty.zamowienia[zk.index]['paczka'] = zamowienie.paczka;
                                    }
                                }

                                $zk_row.find('.paczka-btn').hide();
                                $zk_row.find('.paczkomatEditBtn').hide();
                                $zk_row.find('.wydruk-btn, .etykieta-btn').show();

                                $zk_row.find('.przesylka-numer').html( zamowienie.przesylka.packcode );
                                if ( zamowienie.przesylka.status ) {
                                    $zk_row.find('.przesylka-status').html( zamowienie.przesylka.status );
                                }

                                if ( zamowienie.przesylka.boxMachineName ) {
                                    $zk_row.find('.zk-paczkomat').html( zamowienie.przesylka.boxMachineName + ':' + zamowienie.przesylka.packType );
                                }

                                if ( status ) {
                                    $zk_row.find('.zk-status').html( status );
                                }
                            } else if ( zamowienie.error ) {
                                errors.push('Dla zamwienia ' + zamowienie.NUMER + ' nie udao si wygenerowa paczki, poniewa wystapi bd: ['+zamowienie.error.code +'] ' + zamowienie.error.message );
                            }
                        }

                        if ( errors.length > 0 ) {
                            var errmsg = '<h4>W trakcie generowania paczek wystapiy bdy: </h4><ol>';
                            for ( var i = 0; i < errors.length; i++ ) {
                                errmsg += '<li>' + errors[i] + '</li>' + "\n";
                            }
                            errmsg += '</ol>';

                            $('#paczkomatyPaczkaErrors').html(errmsg).show();
                        }
                    }

                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        $paczkaDialog.dialog("close");
                        $activeDialog = null;
                    }
                }
            }
        }));

        return false;
    }

    function zkLinkClick(e){
        e.preventDefault();

        $dialog.dialog( 'option', 'title', $(this).text() + ' Informacje ');

        $.ajax($.extend({}, settingsAjax, {
            'url' : this.href,
            'dataType':  'html',
            'async' : false,
            'success' : function ( data ) {
                $dialog.html(data);

                $dialog.dialog('option', 'width', '900');
                $dialog.dialog('open');
            }
        }));

        return false;
    }
/**********************************************************************************************************************/
    function ucfirst( str ){
        return str.charAt(0).toUpperCase() + str.slice(1);
    }

    function paczkaChange(e){
        if( e ){
            e.preventDefault();
        }

        var $form = $(this);
        hideLoading();
        $paczkaInfoDialog.dialog( "enable" );

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType': 'json',
            'success': function(data){
                hideLoading();
                $paczkaInfoDialog.dialog( "enable" );

                if ( data && data.message ) {
                    print_message( data.message );
                }

                if ( data && !data.error ) {
                    var form = formGetValues ( $form[0] );
                    var zk = $paczkaInfoDialog.data('zk');
                    var $zk_row = $('#zamowienie' + zk.id + '_row');

                    try {
                        Paczkomaty.zamowienia[zk.index].paczka.customerRef = form.customerRef;
                        Paczkomaty.zamowienia[zk.index].paczka.packType = form.pack_size;

                        $zk_row.find('.zk-paczkomat').html( Paczkomaty.zamowienia[zk.index].paczka.boxMachineName + ':' + form.pack_size );
                    } catch(e){
                        console.log(e);
                    }
                }

                if ( !data.error ) {
                    $paczkaInfoDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));


        return false;
    }

    function paczkaCancel(){
        var paczka = $paczkaInfoDialog.data('paczka');

        showLoading();
        $activeDialog = $paczkaInfoDialog;
        $paczkaInfoDialog.dialog( "disable" );

        $.ajax($.extend({}, settingsAjax, {
            'url' : Paczkomaty.cancel_url,
            'type' : 'POST',
            'data' : {
                'selected' : [{
                    'zk_id' : paczka.zk_id,
                    'packcode' : paczka.packcode,
                    'status' : paczka.status
                }],
                'zk_pack_delete' : 1
            },
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $paczkaInfoDialog.dialog( "enable" );

                print_message( data.message );

                if ( !data.error ) {
                    var $zk_row = $('#zamowienie' + paczka.zk_id + '_row');
                    if ( $zk_row.length ) {
                        zk = $zk_row.metadata(metadataOptions);
                        zk.numer_przesylki = '';
                        zk.przesylka_status = '';
                        $zk_row.attr('data', JSON.stringify(zk));
                    }

                    $zk_row.find('.paczka-btn').show();
                    $zk_row.find('.paczkomatEditBtn').show();
                    $zk_row.find('.wydruk-btn, .etykieta-btn').hide();

                    $zk_row.find('.przesylka-numer').html( '000000000000000000000000' );
                    $zk_row.find('.przesylka-status').html( 'Brak' );

                    if ( data && data.zk_status ) {
                        $zk_row.find('.zk-status').html( data.zk_status );
                    }

                    $paczkaInfoDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));
    }


    function paczkaInfoOpen ( e, data ) {
        //e.preventDefault();

        var $this = $(this);
        if ( !$paczkaInfoDialog ) {
            $paczkaInfoDialog = $('#paczkaInfoDialog').dialog( $.extend({},dialogOptions, {
                'maxWidth': 1100,
                'width' : 800
            }));

            $paczkaInfoDialog.find('.jquery-tabs').tabs();
            $paczkaInfoDialog.find('.jquery-tabs ul').css('width', 'auto');
            $paczkaInfoDialog.find('input[type=submit]').hide();

            $paczkaInfoDialog.find('form').submit(paczkaChange);
        }

/**********************************************************************************************************************/
        $paczkaInfoDialog.find('.message_info, .message_error, .message_notice').html('').hide();

        var zk = $this.parents('tr').metadata();
        var paczka_status = (data && data.status) ?  data.status : ( zk.przesylka_status );

        if ( paczka_status != zk.przesylka_status ) {
            zk.przesylka_status = paczka_status;
            $this.parents('tr').attr('data', JSON.stringify(zk));

            //jesli otrzymalismy informacje o tym e paczka jest anulowana to wyswietlamy stosowny komunikat
            if ( paczka_status == 'Cancelled' ) {
                $paczkaInfoDialog.find('.message_info').html('Uwaga! Paczka zostaa anulowana najprawdopodobniej w menaderze paczek w paczkomaty.pl. Status paczki w e-commerce zosta zaktualizowany i moesz usun paczk dla tego zamwienia, aby wygenerowa now.');
            }
        }

        var $form = $paczkaInfoDialog.find('form');
        $paczkaInfoDialog.data('zk', zk);

        //tworze nowy obiekt bo sa problemy jak konwertuje wartosc zamwienia
        zk = $.extend( {}, zk, Paczkomaty.zamowienia[zk.index]);
        var paczka = zk.paczka;

        if ( !paczka || !paczka.boxMachineName ) {
            print_message('Informacje o paczce nie mog zosta wywietlone. poniewa paczka do zamwienia zostaa najprawdopodobniej utworzona w innym module kurierskim');
            return false;
        }

        paczka.zk_id = zk.ID;
        paczka.packcode = zk.numer_przesylki;
        paczka.pack_size = paczka.packType;
        paczka.status = paczka_status;

        $paczkaInfoDialog.data('paczka', paczka);

        formSetValues ( $form[0], paczka );
        przesylkaZamowienieInfo( zk, 'paczkaInfoZkTemplate', 'paczkaInfoZamowienie' );

        if ( !paczka.insuranceAmount ){
            paczka.insuranceAmount = 0;
        }
        var cena = new Number( paczka.insuranceAmount );
        if ( isNaN(cena) ){
            paczka.insuranceAmount = 0;
        }
        paczka.insuranceAmount = currency_format(paczka.insuranceAmount);

        if ( !paczka.onDeliveryAmount ){
            paczka.onDeliveryAmount = 0;
        }
        cena = new Number( paczka.onDeliveryAmount );
        if ( isNaN(cena) ){
            paczka.onDeliveryAmount = 0;
        }
        paczka.onDeliveryAmount = currency_format(paczka.onDeliveryAmount);

        if ( paczka.senderBoxMachineName || paczka.senderBoxMachineName ){
            $paczkaInfoDialog.find('#paczkaInfoSenderBoxMachine' ).show();
            paczka.customerDelivering = 'Nadam w paczkomacie';
        } else {
            $paczkaInfoDialog.find('#paczkaInfoSenderBoxMachine' ).hide();
            paczka.customerDelivering = 'Zanios do oddziau';
        }

        for ( var o in paczka ) {
            if ( typeof(paczka[o]) == 'object' ) {
                for ( var f in paczka[o] ) {
                    if ( typeof(paczka[o][f]) == 'string' ) {
                        $paczkaInfoDialog.find('#paczkaInfo' + ucfirst(o) + ucfirst(f)).text(paczka[o][f]);
                    }
                }
            } else {
                $paczkaInfoDialog.find('#paczkaInfo' + ucfirst(o)).text(paczka[o]);
            }
        }

/**********************************************************************************************************************/

        var paczkaIDialogOptions = {
            'title' : $this.attr('title')
        };

        paczkaIDialogOptions.buttons = [];
        paczkaIDialogOptions.buttons = [
            {
                'text': "Zamknij",
                'icons' : {'primary' : 'ui-icon-cancel'},
                'click': function() {
                    $(this).dialog("close");
                    hideLoading();
                }
            }
        ];

        paczkaIDialogOptions.buttons.push({
            'text': "Usu",
            'icons': {primary : 'ui-icon-trash'},
            'click': function(){
                var komunikat = '';
                if ( paczka_status == 'Created' ) {
                    komunikat = 'Jeste pewien, e chcesz anulowa paczk w paczkomaty.pl i usun j dla zamwienia?';
                } else {
                    komunikat = 'Jeste pewien, e chcesz usun paczk dla zamwienia? Paczka nie zostanie anulowana w serwisie paczkomaty.pl, poniewa ma status: ' + paczka_status;
                }

                confirmDialog( komunikat, {
                    'confirm' : paczkaCancel
                });
            }
        });

        if ( paczka_status == 'Created' ) {
            paczkaIDialogOptions.buttons.push({
                'text': "Opa",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {
                    showLoading();
                    $paczkaInfoDialog.dialog('disable');
                    $activeDialog = $paczkaInfoDialog;

                    $.ajax($.extend({}, settingsAjax, {
                        'url' : Paczkomaty.payment_url,
                        'data' : {
                            'packcode' : $paczkaInfoDialog.find('input[name=packcode]').val()
                        },
                        'dataType':  'json',
                        'success': function(data){
                            hideLoading();
                            $paczkaInfoDialog.dialog( "enable" );

                            print_message( data.message );

                            //jeszcze zostanie aktualizacja numeru zkStatusu wydania przy zamwieniach
                            errors = zkPaczkiUpdateData(data.object, 'opaci');

                            if ( !data.error ) {
                                $paczkaInfoDialog.dialog("close");
                                $activeDialog = null;
                            }
                        }
                    }));
                }
            });
        }

        if ( paczka_status !== 'Cancelled' ) {
            paczkaIDialogOptions.buttons.push({
                'text': "Etykieta",
                'icons' : {primary : 'ui-icon-print'},
                'click': function() {
                    //zamykam bo po wydrukowaniu etykiety, zmieni sie status z created na inny i bedzie problem z przyciksami
                    $paczkaInfoDialog.dialog("close");

                    var zk_id  = $(this).find("input[name=zk_id]").val();
                    var $zk_row = $('#zamowienie' + zk_id + '_row');
                    $zk_row.find('a.wydruk-btn').click();
                }
            });
        }

        if ( paczka_status == 'Created' ) {
            paczkaIDialogOptions.buttons.push({
                'text': "Zapisz",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {
                    $(this).find("form").submit();
                }
            });

            $paczkaInfoDialog.find('.created1').removeAttr('disabled', 'disabled').removeClass('disabled');
        } else {
            $paczkaInfoDialog.find('.created1').attr('disabled', 'disabled').addClass('disabled');
        }

        $paczkaInfoDialog.dialog('option', paczkaIDialogOptions );
        $paczkaInfoDialog.dialog('open');

        return false;
    }

/**********************************************************************************************************************/

    function setupTable( target ){
        //console.log(setupTable);
        //console.log(target);

        $('.paczka-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-transfer-e-w'
                //'primary' : 'ui-icon-sendpack'
            },
            'text' : false
        }).click(przesylkaOpen);

        $('.wydruk-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-print'
            },
            'text' : false
        }).click(paczkaLabelDialogOpen);

//        $('.paczkomat-edit').editable(SAVE_URL, {
//            indicator : 'Zapis, prosz czeka...',
//            tooltip   : 'Kliknij aby edytowa...'
//        });

        $('.paczkomatEditBtn').button({
            'icons' : {
                //'primary' : 'ui-icon-home'
                //'primary' : 'ui-icon-arrowthickstop-1-s'
                'primary' : 'ui-icon-paczkomat'
            },
            'text' : false
        }).click(zkPaczkomatOpen);

        var paczkaInfoBusy = false;
        $('.info-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-info'
            },
            'text' : false
        }).click( function(e){
            e.preventDefault();

            if( paczkaInfoBusy ) {
                console.log('paczkaInfoBusy');
                return false;
            }
            paczkaInfoBusy = true;

            var zk = $(this).parents('tr').metadata(metadataOptions);
            if ( !zk.numer_przesylki || zk.numer_przesylki == '' ){
                print_message('Dla zamwienia ' + zk.numer + ' nie mona sprawdzi statusu paczki, poniewa nie zostaa wygenrowana przesyka.');
                return false;
            }
            var btn = this;

            showLoading();
            $.ajax($.extend({}, settingsAjax, {
                'url' : this.href,
                'data' : {
                    'zk_id' : zk.id,
                    'status' : zk.przesylka_status,
                    'packcode' : zk.numer_przesylki
                },
                'dataType':  'json',
                //'async' : false,
                'success' : function ( data ) {
                    paczkaInfoBusy = false;
                    hideLoading();
                    data = _str2obj(data);

                    if ( data.error ) {
                        print_message(data.message);
                    } else {
                        paczkaInfoOpen.call( btn, e, data );
                    }
                }
            }));

            return false;
        });

        $('.zk-link', target).click(zkLinkClick);
    }

    $(function(){
        Paczkomaty.callback = paczkomaty_callback;

        $dialog = $('#paczkomatyDialog').dialog(dialogOptions);

        //setupTable( document );
        zkSelection = new EcSelection('paczkomatyContent', {
            'target' : 'paczkomatyZkList',
            'setup' : setupTable,
            'metadata' : metadataOptions
        });

        $('#paczkomatyConfigBtn').button({
            'icons' : {
                'primary' : 'ui-icon-gear'
            },
            'text' : false
        }).click(settingsOpen);

        $('.paczkomatMapBtn').button({
            'icons' : {
                'primary' : 'ui-icon-flag'
            },
            //'text' : 'Wybierz z mapy'
            'text' : false
        }).click(function(e){
            e.preventDefault();
            $paczkomatMapBtn = $(this);
            openMap();
            return false;
        });

        $('.paczkomatSearchBtn').button({
            'icons' : {
                'primary' : 'ui-icon-search'
            },
            'text' : false
        }).click(function(e){
            e.preventDefault();
            $($(this).attr('href')).change();
            return false;
        });

        $('#paczkomatyNadajPrzesylki').click(przesylkaOpen);
        $('#paczkomatyPaczkaSzablonButton').click(przesylkaOpen);
        $('#paczkomatyZamowieniaStatusyButton').click(zkStatusOpen);
        $('#paczkomatyPacksPrintoutBtn').click(paczkiPrintoutDialogOpen);
        $('#paczkomatyDrukujPrzesylki').click(paczkaLabelDialogOpen);
        $('#paczkomatyPacksPayBtn').click(paczkiPaymentDialogOpen);
        $('#paczkomatyPacksCancelBtn').click(paczkiCancelDialogOpen);

        $('select.width-200').css('width', 180);
        $('select.width-100').css('width', 130);
        $('label.width-100').css({'width': 75, 'display' : 'inline-block'});

        $('.template').hide();
        $('.placeholder').textPlaceholder();
        $('a[title].help, a[title].tip').tooltip();
        $('a[rel].help').click(function(e){
            $( this.rel.substr(0,1) == '#' ? this.rel : '#' + this.rel ).slideToggle('slow');
            return false;
        });
    });
})();



