
(function($){
    var _elements;
    var rabaty_progi = {};
    //aktualne progi
    var items = null;
    var $element;
    var $progRabatowyDialog;
    var rabatyProgiIndex = -1;

    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function appendHTML(options){
        if ( _elements && _elements.dialog ){
            return;
        }

        _elements = {};

        _elements.dialog = $('<div>');
        _elements.dialog.css({ 'display' : 'none' }).appendTo('body');
        _elements.dialog.dialog({
            autoOpen: false,
            modal:true,
            width: 500,
            height: 300,
            closeOnEscape: true,
            resizable: false,
            buttons: {
                'Anuluj' : function(){
                    _elements.dialog.dialog('close');
                },
                'Dodaj prg' : progRabatowyDodaj,
                'OK' : zapiszProgiRabatowe
            }
        });

        _elements.dialog.append('<div>Zdefiniowany rabat progowy obowizuje jeli nie jest wybrany aden rabat z programu RAKSSQL.</div>');

        /**
         * Tabela progw
         */
        _elements.table = $('<table class="grid" width="80%" border=0 cellspacing=0 cellpading=5>' + "\n" +
                '<tr>' + "\n" +
                    '<th width="15px">Lp.</th>' + "\n" +
                    '<th>Prg</th>' + "\n" +
                    '<th>Rabat</th>' + "\n" +
                    '<th>Akcje</th>' + "\n" +
                 '</tr>' + "\n" +
            '</table>');

        _elements.dialog.append(_elements.table);

        /**
         * Loader
         */
        _elements.loader = $('<div>');
        _elements.loader.addClass('progress-loading');
        _elements.dialog.append(_elements.loader);
    }

    function floatval( val ){
        if ( typeof(val) == 'string' ) {
            val = val.replace(',', '.');
        }

        val = parseFloat(val);
        if ( isNaN(val) ) {
            val = 0;
        }

        return val;
    }

    function printTable( items ) {
        var rows = _elements.table.find('tr');

        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        if ( items ) {
            for ( var i = 0; i < items.length; i++ ){
                _elements.table.append( printTableRow(items[i], i+1) );
            }
        }
    }

    function printTableRow ( item, lp ) {

        var $row = $('<tr>');
        if ( lp % 2 == 1 ) {
            //$row.addClass('odd');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(progRabatowyUsun);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(progRabatowyEdytuj);

        var $td = $('<td>');

        $row.append($td.clone().html( lp + '. ' ).attr('align', 'right'));
        $row.append($td.clone().html( currency_format(item.prog) ).attr('align', 'right') );
        $row.append($td.clone().html( item.rabat + ' %' ).attr('align', 'right') );
        $row.append($td.attr('align', 'center').append( $a_edit  ).append($a_del) );

        _elements.table.append($row);
    }

    /**
     * Rabat progi on click
     */
    function onClickHandler( e ){
        e.preventDefault();
        var $this = $(this);
        $element = $this;

        var options = $this.data('rabat-progi.items');
        items = rabaty_progi[options['name']];

        printTable( items );

        _elements.dialog.dialog('option', {
            'title' : $this.attr('title')
        });

        _elements.dialog.dialog('open');

        return false;
    }


    function zapiszProgRabatowy( e ){
        if( e && e.preventDefault() ) e.preventDefault();

        var errors = {};
        var i = ( rabatyProgiIndex >= 0 )  ? rabatyProgiIndex : items.length;
        var item = {};

        item.prog = floatval($progRabatowyDialog.find('input[name=prog]').val());
        item.rabat = floatval($progRabatowyDialog.find('input[name=rabat]').val());

        if ( i > 0 && items[i-1] ) {
            if ( item.prog <= items[i-1].prog ) {
                errors.prog = "Warto progu musi by wiksza od " + items[i-1].prog;
            }

            if ( item.rabat <= items[i-1].rabat ) {
                errors.rabat = "Warto rabatu musi by wiksza od " + items[i-1].rabat;
            }
        } else {
            if ( item.prog <= 0 ) {
                errors.prog = "Warto progu musi by wiksza od zera";
            }

            if ( item.rabat <= 0 ) {
                errors.rabat = "Warto rabatu musi by wiksza od zera";
            }
        }

        if ( (i + 1) < items.length ) {
            if ( item.prog >= items[i+1].prog ) {
                errors.prog = "Warto progu musi by mniejsza ni " + items[i+1].prog;
            }

            if ( item.rabat >= items[i+1].rabat ) {
                errors.rabat = "Warto rabatu musi by mniejsza ni " + items[i+1].rabat;
            }
        }

        if ( errors.prog || errors.rabat ) {
            var msg = '';
            if ( typeof($.validator) != 'undefined' ) {
                $progRabatowyDialog.find('form').validate().showErrors( errors );
            } else {
                msg += "\n";
                for( var e in errors ){
                    msg += errors[e] + "\n";
                }
            }

            alert('Popraw bdy!' + msg );
        } else {
            if ( i < items.length ) {
                items[i] = item;
            } else {
                items.push(item);
            }

            printTable( items );
            $progRabatowyDialog.dialog('close');
        }

        return false;
    }

    function zapiszProgiRabatowe ( ) {
        var options;

        if ( $element ) {
            options = $element.data('rabat-progi');
            rabaty_progi[options.name] = items.concat([]);
        } else {
            options = arguments[0];
        }

        $(options.target).find('input').remove();

        for ( var i = 0; i < rabaty_progi[options.name].length ; i++  ){
            for( var a in rabaty_progi[options.name][i] ) {
                $(options.target).append('<input type="hidden" name="'+options.input+'[' + ( i ) + ']['+a+']" value="' + rabaty_progi[options.name][i][a] + '" />');
            }
        }

        items = null;

        if ( $element ) {
            _elements.dialog.dialog('close');
        }
    }

    function progRabatowyDialogOpen ( item ) {

        if( !$progRabatowyDialog ){
            $progRabatowyDialog  = $('#progRabatowyDialog').dialog({
                'open' : false,
                'width' : 600,
                'height' : 240,
                'buttons' : {
                    'Anuluj' : function(){
                        $progRabatowyDialog.dialog('close');
                    },

                    'OK' : zapiszProgRabatowy
                }
            });

            $progRabatowyDialog.find('input[type=submit]').hide();
            $progRabatowyDialog.find('form').submit(zapiszProgRabatowy);
        }

        $progRabatowyDialog.find('input[type=text]').val('');
        if ( item ) {
            for ( var a in item ) {
                $progRabatowyDialog.find('input[name=' + a + ']').val(item[a]);
            }
        }

        $progRabatowyDialog.dialog('open');
    }

    function progRabatowyDodaj ( ) {
        rabatyProgiIndex = -1;

        progRabatowyDialogOpen();
    }

    function progRabatowyEdytuj ( e ) {
        e.preventDefault();

        var $tr = $(this).parents('tr');
        rabatyProgiIndex = $tr.index() - 1;
        progRabatowyDialogOpen( items[rabatyProgiIndex] );

        return false;
    }

    function progRabatowyUsun ( e ) {
        e.preventDefault();

        if ( confirm('Jeste pewien, e chcesz usun prg rabatowy?') ) {
            var $tr = $(this).parents('tr');
            var i = $tr.index() - 1;

            items.splice( i, 1);

            printTable( items );
        }

        return false;
    }

    if ( $.fn.rabatProgi ) {
        return;
    }


    $.fn.rabatProgi = function( options ){
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        options = $.extend({
            items : [],
            name  : $(this).attr('id'),
            target : $(this).attr('rel'),
            title : $(this).attr('title'),
            select : ''
        }, options || {} );

        if ( options.target && options.target.substr(0,1) != '#' ){
            options.target = '#' + options.target;
        }

        if ( options['items'] ) {

        }

        rabaty_progi[options['name']]  = options['items'];

        appendHTML();

        delete options['items'];

        this.data ( 'rabat-progi', options );

        this.button({
            'text' : '',
            'icons' : {
                'primary' : 'ui-icon-plus'
            }
        }).click ( onClickHandler );

        zapiszProgiRabatowe(options);
    }
})(jQuery);
