// JavaScript Document
var active_grid = '';

function Grid( grid_id, setup ){

    this.o_table = document.getElementById(grid_id);
    if( !this.o_table ){
        alert('Nie odnaleziono tabelki  o id: ' + grid_id );
        return;
    }
    

    if( !this.o_table ){
        alert('Nie znaleziono w dokumencie gridu: ' + grid_id);
        return false;
    }

    this.setup = setup;

    if( !setup.no_grid ){
        this.o_table.parentNode.className = 'grid';
    }

    this.onenter = null;
    this.ondelete =  null;
    this.onescape =  null;
    this.onspace = null;
    this.onright = null;
    this.onleft  = null;
    this.oninsert = null;

    this.onctrlup = null;
    this.onctrldown = null;

    for( f in setup ){
        if( typeof( setup[f] ) == 'function' ){
            this[f] = setup[f];
        }
    }
    
    this.onkeydown = grid_onkeydown;
    this.onclick = grid_onclick;

    this.active = false;
    
    var o_self = this;

    this.o_table.onclick = function( e ){
        if( o_self && !o_self.active ){
            o_self.active = true;
            
            add_event('onkeydown', document, function(e){ o_self.onkeydown(e) }, true );
            add_event('onclick', document, function(e){ o_self.onclick(e) }, true );
            
            if( arguments.length > 0 ) o_self.onclick(arguments[0]);
        }
    }

    if( setup.init ){
        this.row = 0;

        podswietl_wiersz( this.o_table.rows[1] );
        
        this.o_table.onclick();
    }
}

function grid_onclick( e ){
    e = (!e) ? window.event : e;

    // pobiera adresata zdarzenia
    var target = (!e.target) ? e.srcElement : e.target;
    var o_tr, o_td;
    if (target.nodeType == 3) target = target.parentNode;

    var o_obj = target;
    var znaleziono = false;
    while( o_obj && !znaleziono ){
        if( o_obj.id == this.o_table.id ){
            znaleziono = true;
        }else if( o_obj.nodeName == 'TR' ){
            o_tr = o_obj;
        }

        o_obj = o_obj.parentNode;
    }

    if( znaleziono ){
        if( target.nodeName == 'INPUT' && target.type == 'checkbox' ){
            target.blur();
        }

        this.row = o_tr.rowIndex - 1;
    }else{
        remove_event( 'click', document );
        remove_event( 'keydown', document );

        this.row  = -1;
        this.active = false;
        
        podswietl_wiersz(null);
    }
}

function grid_onkeydown( e ){
    // pobiera zdarzenie
    e = (!e) ? window.event : e;

    // pobiera adresata zdarzenia
    var target = (!e.target) ? e.srcElement : e.target;

    if (target.nodeType == 3) target = target.parentNode;

    // pobiera kod znaku nacinitego klawisza
    var code = (e.charCode) ? e.charCode :((e.keyCode) ? e.keyCode :((e.which) ? e.which : 0));

    var old_num = 0;

    var stop_propagation = false;


    var rows_count = this.o_table.rows.length - 1;
    var o_tr = this.o_table.rows[(this.row + 1)];

    switch( code ){
        case 13: // enter
            if( typeof(this.onenter) == 'function' ){
                this.onenter( this.row, o_tr );

                grid_stop_propagation( e );
            }

            return false;
        break;

        case 46: // delete
            if( typeof(this.ondelete) == 'function' ){
                this.ondelete( this.row, o_tr );

                grid_stop_propagation( e );
            }

            return false;
        break;

        case 27: // escape
            if( typeof(this.onescape) == 'function' ){
                stop_propagation = true;

                this.onescape( this.row, o_tr );

                grid_stop_propagation( e );

                return false;
            }
        break;

        case 32: //spacja
          if( typeof(this.onspace) == 'function' ){
              grid_stop_propagation( e );

              this.onspace( this.row, o_tr);
          }
          return false;
        break;

        case 96: //insert
          if( typeof(this.oninsert) == 'function' ){
              grid_stop_propagation( e );

              this.oninsert( this.row, o_tr);
          }
          return false;
        break;


        //klawisz End
        case 35:
            stop_propagation = true;

            old_num  = this.row;
            this.row = rows_count - 1;
        break;

        //klawisz Home
        case 36:
            stop_propagation = true;

            old_num = this.row;
            this.row = 0;
        break;

        case 37: // left arrow
            if( typeof(this.onleft) == 'function' ){

                this.onleft( this.row, o_tr );

                grid_stop_propagation( e );

                return false;
            }
        break;

        // nacinicie strzaki w g przenosi nas do poprzedniej podpowiedzi
        case 38:
          //stop_propagation = true;
          grid_stop_propagation( e );

          //console.log('onctrlup');
          
          if( e.ctrlKey && (typeof(this.onctrlup) == 'function') ){
              this.onctrlup( this.row, o_tr );
          }

          if( this.row > 0 ){
              old_num = this.row--;
          }else if(this.row == 0){
              old_num = this.row;
              this.row = rows_count - 1;
          }
        break;

        case 39: // right arrow
            if( typeof(this.onright) == 'function' ){

                this.onright( this.row, o_tr );

                grid_stop_propagation( e );

                return false;
            }
        break;


        // po naciniciu strzaki w d przechodzi do kolejnej podpowiedzi
        case 40:
          //stop_propagation = true;

          grid_stop_propagation( e );
          
          if(  e.ctrlKey && (typeof(this.onctrldown) == 'function') ){
              this.onctrldown( this.row, o_tr );
          }
          
          if( this.row < rows_count - 1 ){
              old_num = this.row++;
          }else{
              old_num = this.row;
              this.row = 0;
          }
        break;
    } //case

    o_tr = this.o_table.rows[(this.row + 1)];
    var o_grid_parent_div = this.o_table.parentNode;

    if( o_tr ){
        podswietl_wiersz(o_tr);
    
        var y, y1  = 0;

        if( o_grid_parent_div && (o_grid_parent_div.clientHeight < this.o_table.scrollHeight) ){
            y1 = o_tr.offsetTop;
            y = (o_tr.offsetTop + o_tr.scrollHeight);


        } else { //biore dokumen
            y1 = find_pos_y(o_tr)
            y = y1 + o_tr.scrollHeight ;

            o_grid_parent_div = document.body;
        }

        if( y > (o_grid_parent_div.scrollTop + o_grid_parent_div.clientHeight ) ){

            o_grid_parent_div.scrollTop = ((y - o_grid_parent_div.clientHeight) );

        }else if( y1 < o_grid_parent_div.scrollTop ){

            o_grid_parent_div.scrollTop = y1;
        }

    }

    if( stop_propagation ){
        grid_stop_propagation( e);
        return false;
    }

    return true;
}

function grid_stop_propagation( e ){
    e.cancelBubble = true;
    e.returnValue = false;

    try{
      e.stopPropagation();
      e.preventDefault();
    }catch(err){}
}
