// JavaScript Document
var EC_DEBUG = true;

var inpost_params = [],
    inpost_machines = null,
    inpost_towns = null,
    inpost_google_map = null,
    inpost_marker = null,
    $inpost_map = null,
    inpost_google_script = false;

function ec_log () {
    //alert ( typeof(console) );
    if ( arguments.length > 0 ) {
        if ( typeof(EC_DEBUG) == 'boolean' && EC_DEBUG && typeof(console) == 'object' ){
          // join for graceful degregation
          var args = (arguments.length > 1) ? Array.prototype.join.call(arguments, " ") : arguments[0];
          // this is the standard; firebug and newer webkit browsers support this
          try {
            console.log(args);
            return true;
          } catch(e) {
            //newer opera browsers support posting erros to their consoles
            try {
              opera.postError(args);
              return true;
            } catch(e) { }
          }

          // catch all; a good old alert box
          if ( typeof(jQuery) == 'undefined' ) {
            alert(args);
          } else {
            //add div to document root
          }

          return false;
        }
    }
}

function is_jquery() {
    return !( typeof(jQuery) == 'undefined' );
}

function jQueryInit() {
    if ( !is_jquery() && ( typeof(jQueryInitFlag) == 'undefined' || !jQueryInitFlag ) ) {
        // jQuery is not loaded
        css_load(SCRIPT_URL + '/ui1.8/jquery-ui-1.8.custom.css');
        script_load(SCRIPT_URL +'/jquery/jquery-1.4.2.min.js');
        script_load(SCRIPT_URL +'/ui1.8/jquery-ui-1.8.1.all.min.js');

        jQueryInitFlag = true;
    }

    return true;
}

function inpost_sposob_dostawy_onchage() {
    if ( typeof(INPOST_SP_DOST_ID) != 'undefined' && INPOST_SP_DOST_ID > 0 ) {
        if ( INPOST_SP_DOST_ID == this.value ) {
            $paczkomat.parents('tr').show();
        } else {
            $paczkomat.parents('tr').hide();
        }
    }
}

function paczkomatyInit() {
    if ( typeof(paczkomatyInitFlag) == 'undefined' || !paczkomatyInitFlag ){

      if ( !jQueryInit() ) {
          return;
      }

      if ( !is_jquery() ) {
        ec_log('setTimeout("paczkomatyInit()", 3000 );');
        setTimeout ("paczkomatyInit()", 3000 );
        return;
      }

      paczkomatyInitFlag = true;

      jQuery.ajax( {
        'url' : MAIN_URL  + '?action=inpost&mode=init&ajax=1',
        'success' : function ( data ) {
            if ( data['object'] ) {
              INPOST_SP_DOST_ID = data['object']['INPOST_SP_DOST_ID'];

              if ( INPOST_SP_DOST_ID > 0 ) {
                  jQuery('select[name=SPOSOB_DOSTAWY]').change(inpost_sposob_dostawy_onchage);
              }

              inpost_params = data['object']['inpost_params'];
              inpost_machines = data['object']['inpost_machines'];
              inpost_towns = data['object']['inpost_towns'];
              userdata = data['object']['osoba'];

              var html_data = '';

              if ( data['object']['html'] ) {
                  html_data = data['object']['html'];
              }else if ( data['object']['paczkomaty'] ) {
                  html_data = data['object']['paczkomaty'];
              }

              if ( userdata.email ) {
                  $input = jQuery('select[name=ADRES_DOSTAWY]' );
                  $row = $input.parents('tr').clone();
              } else {
                  $input = jQuery('form[name="zamowienie_form"] input[name="email"]' );
                  if( $input.length == 0 ){
                      $input = jQuery('input[name="email"]');
                  }

                  $row = $input.parents('tr').clone();
              }

              $row.children('td:first-child').html( 'Wybierz paczkomat: ' );
              $row.children('td:last-child').html( html_data ).attr('id', 'paczkomat');
              $input.parents('tr').after( $row );

              $paczkomat = $row.find('#paczkomat');
              $paczkomat.parents('tr').hide();
            }
        },

        'error' : function(jqXHR, textStatus, errorThrown ){
            console.log(errorThrown);
        },

        'dataType' : 'json'
      });
    }

    return true;
}

function inpost_wybierz_paczkomat () {

    $input = jQuery('input[name="inpost[paczkomat]"]');

    if ( $input.length == 0 ) {
        $input = jQuery('select[name="inpost[paczkomat]"]' );
    }

    var paczkomat = $input.val();

    ec_log('wybrany paczkomat: ' + paczkomat );

    if ( paczkomat ) {
        alert('Wybierz paczkomat');
    }

    var inpost_map = {
        '' : ''
    };

    var k, v, data;
    for( k in inpost_map ){
        v = inpost_map[k];
        data['inpost[' + v +']'] = '';
    }

}

function inpost_najblizsze_paczkomaty( ){
    ec_log('inpost_najblizsze_paczkomaty');
}

function inpost_miasto_onchange ( m ) {
  if ( !is_jquery() ) {
    return false;
  }

  if ( typeof(inpost_machines) != 'object') {
    return false;
  }

  var $m = null;
  if ( !m ) {
      $m = jQuery('#inpost_miasto');
  }else{
      $m = jQuery( m );
  }

  if ( !$m.val() ) {
      return false;
  }

  var miasto = $m.find("option:selected").text();

  var $ipaczkomat = jQuery('#inpost_paczkomat');
  if ( $ipaczkomat.length == 0 ) {
      $ipaczkomat = jQuery('<select id="inpost_paczkomat" name="inpost[paczkomat]"></select>' );
      jQuery('#inpost_paczkomaty').html('').append( $ipaczkomat);
  } else {
      $ipaczkomat.children('option').remove();
  }

  if ( $ipaczkomat.length == 0 ) return false;

  var machine = null ; var opcje = { 0 : 'Wybierz' };
  for ( var im in inpost_machines ){
      machine = inpost_machines[im];

      if ( machine['town'] == miasto ) {
          opcje[im] = machine['name']+" "+machine['street']+" "+machine['buildingnumber']+", "+machine['postcode']+" "+machine['town'];
      }
  }

  if ( opcje.length <= 1 ) {
    for ( var im in inpost_machines ){
        machine = inpost_machines[im];
        opcje[im] = machine['name']+" "+machine['street']+" "+machine['buildingnumber']+", "+machine['postcode']+" "+machine['town'];
    }
  }

  var options = $ipaczkomat.attr('options');
  for ( var o in opcje ) {
      options[options.length] = new Option(opcje[o], o);
  }
}

function ec_site_url(){
    if ( typeof(SITE_URL) == 'string' ){
        return ( SITE_URL.substring(0, 4) == 'http' ? '' : window.location.protocol + '//'  ) + SITE_URL;
    }else{
        return window.location.protocol + '//' + window.location.host;
    }
}

function inpost_paczkomat_pokaz_na_mapie( paczkomat ){

  //ec_log ( 'inpost_paczkomat_pokaz_na_mapie('+ ( arguments.length  > 0 ? paczkomat : '') + '); ');

  if ( (typeof(google) == 'undefined' || typeof(google.maps) == 'undefined') && ( typeof(inpost_google_script) == 'undefined' || !inpost_google_script )  ) {
      //ec_log( 'Initialize google map' );
      var script = document.createElement("script");
      script.src = "http://maps.google.com/maps/api/js?sensor=false&callback=inpost_paczkomat_pokaz_na_mapie";
      script.type = "text/javascript";
      document.body.appendChild(script);
      inpost_google_script = true;
      return;
  }else{
      ec_log( 'GOOGLE MAP initialized, google: '+ typeof(google) + ', google.maps: ' + typeof(google.maps) );
  }

  if ( arguments.length == 0 || !paczkomat ) {
      paczkomat = jQuery('#inpost_paczkomat').val();
  }

  if ( typeof( inpost_machines ) != 'object') {
      return false;
  }

  if ( !paczkomat ) {
      alert('Wybierz najpierw paczkomat');
      return false;
  }

  if ( typeof(inpost_machines[paczkomat]) == 'undefined' ) {
      alert('Zosta wybrany niewaciwy paczkomat');
      return false;
  }

  if ( typeof(jQuery.ui) == 'undefined' ){
      // UI not loaded
      css_load(SCRIPT_URL + '/ui1.8/jquery-ui-1.8.custom.css');
      script_load(SCRIPT_URL +'/ui1.8/jquery-ui-1.8.1.all.min.js');
  }

  var machine = inpost_machines[paczkomat];
  var machine_loc = new google.maps.LatLng(machine.latitude, machine.longitude);

  if ( !$inpost_map || !inpost_google_map ) {
    if ( !$inpost_map ) {
      var inpost_map_canvas = document.createElement('div');
      inpost_map_canvas.id = 'inpost_map_canvas';

      jQuery(inpost_map_canvas).css({'width' : '100%','height' : '100%'});
      $inpost_map = jQuery(document.createElement('div')).css({'width' : '100%','height' : '100%'}).attr('id', 'inpost_map').append(inpost_map_canvas);
      $inpost_map.appendTo('body');

      $inpost_map.dialog({
          autoOpen: false,
          draggable: true,
          height: 480,
          width: 640,
          modal: true,
          resizable: false,
          title : ''
      });
    }
    inpost_google_map = new google.maps.Map( inpost_map_canvas );
  }else if( inpost_marker ) {
    inpost_marker.setMap(null);
  }

  inpost_google_map.setOptions({
      zoom: 14,
      center: machine_loc,
      scaleControl: false,
      scrollwheel: false,
      mapTypeId: google.maps.MapTypeId.ROADMAP
  });

//   ec_log('inpost_google_map: ' );
//   for ( var f in inpost_google_map ){
//       ec_log('    ' + f + ': ' + typeof(inpost_google_map[f]));
//   }

  inpost_marker = new google.maps.Marker({
      position: machine_loc,
      map: inpost_google_map,
      title: machine.town + ', ' + machine.street + ' ' + machine.buildingnumber,
      icon : ec_site_url() + IMAGES_URL + '/paczkomaty/google-icon-' + ( machine.paymenttype ? '1' : '0' ) + '.png'
  });

  var contentString =
      '<div class="google_map_paczkomat">' +
        '<h3>Lokalizacja Paczkomatu</h3>' +
        '<strong>' + machine.name + '</strong>' +
        '<p>' +
            machine.street + ' ' +  machine.buildingnumber  + '<br />' +
            machine.postcode + ' ' +  machine.town +
        '</p>' +
        '<p>' +  machine.locationdescription + '</p>' +
        '<p>' +  machine.paymentpointdescr + '</p>' +
        '<p>' +
          '<a target=_blank href="http://www.paczkomaty.pl/images/paczkomaty/small/' + machine.name + '.jpg">' +
            '<img alt="' + machine.name + '" src="http://www.paczkomaty.pl/images/paczkomaty/small/' + machine.name + '.jpg">' +
          '</a>' +
        '</p>' +
      '</div>';

    var infowindow = new google.maps.InfoWindow({
        content: contentString
    });

    google.maps.event.addListener(inpost_marker, 'click', function() {
        infowindow.open(inpost_google_map, inpost_marker);
    });

    $inpost_map.dialog( "option", "title",  machine.name );
    $inpost_map.dialog('open');
}


jQueryInit();

paczkomatyInit();


