// JavaScript Document
var showTipTime;
var hideTipTime;

function addEvent(type, obj, fn, cpt){
	if(null != obj){
		if(obj.attachEvent){
			obj['e'+type+fn] = fn;
			obj[type+fn] = function(){obj['e'+type+fn](window.event)}
			obj.attachEvent('on'+type, obj[type+fn]);
		}else{
			obj.addEventListener(type, fn, cpt);
		}
	}
}

function removeEvent(type, obj, fn, cpt){
	if(obj.detachEvent){
		obj.detachEvent('on'+type, obj[type+fn]);
		obj[type+fn] = null;
	}else{
		obj.removeEventListener(type, fn, cpt);
	}
}

function GetElementsByClass(className)
{
	var classElements = new Array();
	var els = document.getElementsByTagName("*");
	var elsLen = els.length;
	var pattern = new RegExp("\\b" + className + "\\b");
	for (i = 0, j = 0; i < elsLen; i++) {
		if ( pattern.test(els[i].className) ) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}

function stopBubble(e){
	if(!e) var e = window.event;
	e.cancelBubble = true;
	if(e.stopPropagation) e.stopPropagation();
}

function getMainTipElements(){
	mainTipTexts = GetElementsByClass("tips");
	mainTipImgs = GetElementsByClass("tip-img");
	mainTipBgs = GetElementsByClass("tip-bg");
}

function showTooltip(e){
	stopBubble(e);
	mainTip = (e.target) ? e.target : e.srcElement;
	showTipTime = setTimeout("showTip()",0);
	(e.preventDefault) ? e.preventDefault() : (e.returnValue = false);
}

function hideTooltip(e){
	stopBubble(e);
	hideTipTime = setTimeout("hideTip()",0);
	(e.preventDefault) ? e.preventDefault() : (e.returnValue = false);
}

function showTip(){
	clearTimeout(showTipTime);
//	tipPosX = mainTip.offsetLeft;
//	tipPosY = mainTip.offsetTop;

	var body=document.getElementsByTagName("body");
	var tempVar=mainTip;
	var xt=tempVar.offsetLeft;
	var yt=tempVar.offsetTop;

	while(tempVar.offsetParent!=body[0])
	{
		tempVar=tempVar.offsetParent;
		xt=xt+tempVar.offsetLeft;
		yt=yt+tempVar.offsetTop;
	}
	tipPosX=xt;
	tipPosY=yt;

	mainTipTextId = mainTip.getAttribute("maintiptxt");
	mainTipText = document.getElementById(mainTipTextId);
	mainTipImgId = mainTip.getAttribute("maintipimg")
	mainTipImg = document.getElementById(mainTipImgId);
	mainTipBgId = mainTip.getAttribute("maintipbg")
	mainTipBg = document.getElementById(mainTipBgId);
	mainTipText.style.display = "block";
	mainTipTextWidth = Math.ceil(mainTipText.clientWidth );
	mainTipText.style.width = (mainTipTextWidth > 142) ? "142px" : mainTipTextWidth + 'px';
	mainTipText.style.left = tipPosX + mainTip.clientWidth + 18 + 'px';
	mainTipText.style.top = tipPosY - Math.floor(mainTipText.clientHeight/2) + 10 + 'px';
	mainTipImg.style.left = tipPosX + mainTip.clientWidth + 2 + 'px';
	mainTipImg.style.top = tipPosY - Math.floor(mainTipText.clientHeight/2) + 5 + 'px';
	mainTipBg.style.left = tipPosX + mainTip.clientWidth + 9 + 'px';
	mainTipBg.style.top = tipPosY - Math.floor(mainTipText.clientHeight/2) + 7 + 'px';
	tipImgWidth = Math.ceil(mainTipText.clientWidth+30);
	tipImgHeight = Math.ceil(mainTipText.clientHeight/2);
	mainTipImg.style.width = tipImgWidth + 2 + 'px';
	mainTipImg.style.height = tipImgHeight + 2 + 'px';
	mainTipBg.style.width = tipImgWidth - 6 + 'px';
	mainTipBg.style.height = (tipImgHeight*2) + 7 + 'px';
	setTipSize(tipImgWidth, tipImgHeight);
	mainTipImg.style.display = "block";
	mainTipBg.style.display = "block";
	tipTopPosX = mainTipBg.offsetLeft;
	tipTopPosY = mainTipBg.offsetTop;
	tipBottomPosX = tipTopPosX + mainTipBg.clientWidth;
	tipBottomPosY = tipTopPosY + mainTipBg.clientHeight;
}

function stopTooltip(e){
	stopBubble(e);
	(e.preventDefault) ? e.preventDefault() : (e.returnValue = false);
}

function hideAllMainTips(){
	for(i=0; i<mainTips_sl.length; i++){
		mainTipTexts[i].style.display = "none";
	}
		mainTipBgs[0].style.display = "none";
		mainTipImgs[0].style.display = "none";
}

function hideTip(){
	clearTimeout(hideTipTime);

	mainTipText.style.display = "none";
	mainTipImg.style.display = "none";
	mainTipBg.style.display = "none";
	hideAllMainTips();
}

function setTipSize(tWidth, tHeight){
	var tHorizontalLineWidth = (tWidth > 0) ? tWidth - 12 + 'px' : 0;
	var tVerticalLineHeight = (tHeight > 0) ? tHeight - 5 + 'px' : 0;
	if(mainTipImg.id == "mimg"){
		var tipTopMiddle = document.getElementById("gora-srodek");
		var tipBottomMiddle = document.getElementById("dol-srodek");
		var tipMiddleTopLeft = document.getElementById("srodek-gora-lewo");
		var tipMiddleTopRight = document.getElementById("srodek-gora-prawo");
		var tipMiddleBottomLeft = document.getElementById("srodek-dol-lewo");
		var tipMiddleBottomRight = document.getElementById("srodek-dol-prawo");
	}else{
		var tipTopMiddle = document.getElementById("gora-srodekr");
		var tipBottomMiddle = document.getElementById("dol-srodekr");
		var tipMiddleTopLeft = document.getElementById("srodek-gora-lewor");
		var tipMiddleTopRight = document.getElementById("srodek-gora-prawor");
		var tipMiddleBottomLeft = document.getElementById("srodek-dol-lewor");
		var tipMiddleBottomRight = document.getElementById("srodek-dol-prawor");
	}

	tipTopMiddle.style.width = tHorizontalLineWidth;
	tipBottomMiddle.style.width = tHorizontalLineWidth;

	tipMiddleTopLeft.style.height = tVerticalLineHeight;
	tipMiddleTopRight.style.height = tVerticalLineHeight;
	tipMiddleBottomLeft.style.height = tVerticalLineHeight;
	tipMiddleBottomRight.style.height = tVerticalLineHeight;
/*
	tipTopMiddle =
	tipBottomMiddle =
	tipMiddleTopLeft =
	tipMiddleTopRight =
	tipMiddleBottomLeft =
	tipMiddleBottomRight =
*/
	return true;
}


/*window.onload = function(){
	mainTips_sl = GetElementsByClass("tipcat");
	for(i=0; i<mainTips_sl.length; i++){
		addEvent('mouseover', mainTips_sl[i], showTooltip, false);
		addEvent('mouseover', mainTips_sl[i], stopTooltip, false);
		addEvent('mouseout', mainTips_sl[i], hideTooltip, false);
	}
}*/
