/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE TABLE WWW_AU_CATS (
    ID          INTEGER NOT NULL,
    PARENT_ID   INTEGER,
    SERWIS      INTEGER NOT NULL,
    "POSITION"  INTEGER NOT NULL,
    NAME        STRING250_D NOT NULL /* STRING250_D = VARCHAR(250) */,
    SKLEP       BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_AU_CATS ADD CONSTRAINT WWW_AU_CATS_PK PRIMARY KEY (ID, SERWIS);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_AU_CATS_PARENT_ID_IND ON WWW_AU_CATS (PARENT_ID);
CREATE INDEX WWW_AU_CATS_POSITION_IND ON WWW_AU_CATS ("POSITION");


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_AU_CATS TO WWW_ROLE;
