
CREATE GENERATOR WWW_VFS_ID_GEN;

CREATE TABLE WWW_VFS (
    ID                     ID_D NOT NULL /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    VFS_ID                 SLOWNIK_D NOT NULL /* SLOWNIK_D = INTEGER */,
    WYSWIETL               BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    NAZWA                  STRING200_D NOT NULL /* STRING200_D = VARCHAR(200) */,
    FILTR                  STRING250_D /* STRING250_D = VARCHAR(250) */,
    LOGGED                 BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    ESKLEP                 BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    B2B                    BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    MOBILE                 BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    IMG_WATERMARK_ID       SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    IMG_WATERMARK_OPACITY  SMALLINT,
    PDF_SET_PROTECTION     BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    PDF_PRINT              SMALLINT NOT NULL,
    PDF_MODIFY             BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    PDF_COPY               BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    PDF_ANNOT_FORMS        BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    PDF_USER_PASS          STRING50_D COLLATE PXW_PLK /* STRING50_D = VARCHAR(50) */,
    PDF_OWNER_PASS         STRING50_D COLLATE PXW_PLK /* STRING50_D = VARCHAR(50) */,
    PDF_WATERMARK_ID       SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    PDF_TEXT               STRING200_D COLLATE PXW_PLK /* STRING200_D = VARCHAR(200) */,
    PDF_TEXT_STYLE         STRING200_D COLLATE PXW_PLK /* STRING200_D = VARCHAR(200) */,
    CDATE                  DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */,
    MDATE                  DATA_TIME_D /* DATA_TIME_D = TIMESTAMP */
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_VFS ADD CONSTRAINT WWW_VFS_VFS_ID_UNQ UNIQUE (VFS_ID);


/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_VFS ADD CONSTRAINT WWW_VFS_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_VFS_DATY_IND ON WWW_VFS (CDATE, MDATE);


/* Fields descriptions */

DESCRIBE FIELD ID TABLE WWW_VFS
'Wzr typu dla identyfikatora pozycji sownika danych';

DESCRIBE FIELD VFS_ID TABLE WWW_VFS
'Wzr typu dla identyfikatora pozycji sownika danych';

DESCRIBE FIELD ESKLEP TABLE WWW_VFS
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD B2B TABLE WWW_VFS
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD MOBILE TABLE WWW_VFS
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD CDATE TABLE WWW_VFS
'Wzr typu dla pl zawierajcych dat';

DESCRIBE FIELD MDATE TABLE WWW_VFS
'Wzorzec dla pl zawierajcych dat i czas';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_VFS TO WWW_ROLE;
