
/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_SEO_ID_GEN;

CREATE TABLE WWW_SEO (
    ID           INTEGER NOT NULL,
    MODEL        VARCHAR(30) NOT NULL,
    MODEL_ID     INTEGER NOT NULL,
    MODEL_NAZWA  STRING200_D COLLATE PXW_PLK /* STRING200_D = VARCHAR(200) */,
    SLUG         VARCHAR(250) NOT NULL,
    CDATE        DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */,
    MDATE        DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_SEO ADD CONSTRAINT WWW_SEO_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_SEO_DATY_IND ON WWW_SEO (CDATE, MDATE);
CREATE UNIQUE INDEX WWW_SEO_MODEL_NAME_ID_IND ON WWW_SEO (MODEL, MODEL_ID);
CREATE UNIQUE INDEX WWW_SEO_SLUG_IND ON WWW_SEO (SLUG);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_SEO_BI */
CREATE TRIGGER WWW_SEO_BI FOR WWW_SEO
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_SEO_ID_GEN,1);
END
^


SET TERM ; ^




/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_SEO TO WWW_ROLE;