/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_NEWS_ID_GEN;

CREATE TABLE WWW_NEWS (
    ID        INTEGER NOT NULL,
    TYTUL     VARCHAR(250) NOT NULL,
    WYSWIETL  BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    DATA_DO   DATE,
    DATA_OD   DATE,
    WSTEP     BLOB SUB_TYPE 1 SEGMENT SIZE 512,
    TRESC     BLOB SUB_TYPE 1 SEGMENT SIZE 1024,
    CDATE     TIMESTAMP NOT NULL,
    MDATE     TIMESTAMP NOT NULL
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_NEWS ADD CONSTRAINT WWW_NEWS_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_NEWS_DATY_IND ON WWW_NEWS (CDATE, MDATE);
CREATE INDEX WWW_NEWS_SERACH_IND ON WWW_NEWS (WYSWIETL, DATA_DO, DATA_OD);
CREATE INDEX WWW_NEWS_TYTUL_IND ON WWW_NEWS (TYTUL);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_NEWS_BI */
CREATE TRIGGER WWW_NEWS_BI FOR WWW_NEWS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_NEWS_ID_GEN,1);
END
^


SET TERM ; ^



/* Fields descriptions */

DESCRIBE FIELD WYSWIETL TABLE WWW_NEWS
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_NEWS TO WWW_ROLE;