<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {make_btn} function plugin
 *
 * File:       function.make_btn.php<br>
 * Type:       function<br>
 * Name:       make_btn<br>
 * Date:       2007-11-15<br>
 * Purpose:    Prints out a list of checkbox input types<br>
 * Input:<br>
 *           - napis      (required) - string default "checkbox"
 *           - adres      (optional) - string default ""
 *           - parametry  (optional) - string default array()
 * Examples:
 * <pre>
 * {make_btn napis="Przycisk" output="index.php"}
 * {make_btn napis="Przycisk" output="#" onclick="document.forms[0].submit();" style="color: red;"}
 * </pre>
 * @author     Jarek Kotowski <jarek@solution-4u.com>
 * @version    1.0
 * @param array
 * @param Smarty
 * @return string
 */
function smarty_function_make_btn($params, &$smarty){
    $napis = '';
    $adres = '';
    $parametry = array();
    $extra = '';
    $css = '';
    
    foreach($params as $_key => $_val) {
        switch($_key) {
            case 'napis':
                $$_key = (string)$_val;
            break;
                
            case 'name':
                $napis = (string)$_val;
            break;

            case 'adres':
                $$_key = (string)$_val;
            break;
            
            case 'class':
                $css = (string)$_val;
            break;
                
            default:
                if( !is_array($_val) ) {
                    $extra .= ' '.$_key.'="'.addcslashes($_val, '"').'"';
                }
            break;
        }
    }

    
    return '<div class="btn '.$css.'" '.(empty($adres)?'':'onclick="location=\''.$adres.'\'"').' '.$extra.'><div class=btnl></div><div class="btnr"></div><div class="btnbg">'.$napis.'</div></div>';

}
    







?>
